// JavaScript Document

$(document).ready(function () {
    $("a[rel='lightbox']").colorbox({transition: "fade"});
    $(".uloadfilesima").colorbox(
        {
            width: "1040px",
            height: "500px",
            iframe: true,
            overlayClose: false,
            onComplete: function ()
            {
                /*alert('onComplete: colorbox has displayed the loaded content'); */
            }
        });
});

function ResizeColorbox(settings_object)
{
    $.colorbox.resize(settings_object)
}
$(function () {
    $("#tabs").tabs().find(".ui-tabs-nav");

//Notificaciones
    $('.message').hide().append('<span class="close" title="Cerrar"></span>').fadeIn('slow');
    $('.message .close').hover(
        function () {
            $(this).addClass('hover');
        },
        function () {
            $(this).removeClass('hover');
        }
    );

    $('.message .close').click(function () {
        $(this).parent().fadeOut('slow', function () {
            $(this).remove();
        });
    });

//Tabla
    // Alternating table rows:

    $('tbody tr:even').addClass("alt-row"); // Add class "alt-row" to even table rows

    // Check all checkboxes when the one in a table head is checked:

    $('.check-all').click(
        function () {
            $(this).parent().parent().parent().parent().find("input[type='checkbox']").attr('checked', $(this).is(':checked'));
        }
    );

// Sidebar Tabs
    $(".sidebar_content").hide();

    if (window.location.hash && window.location.hash.match('sb')) {

        $("ul.sidemenu li a[href=" + window.location.hash + "]").parent().addClass("active").show();
        $(".block .sidebar_content#" + window.location.hash).show();
    } else {

        $("ul.sidemenu li:first-child").addClass("active").show();
        $(".block .sidebar_content:first").show();
    }

    $("ul.sidemenu li").click(function () {

        var activeTab = $(this).find("a").attr("href");
        window.location.hash = activeTab;

        $(this).parent().find('li').removeClass("active");
        $(this).addClass("active");
        $(this).parents('.block').find(".sidebar_content").hide();
        $(activeTab).show();
        return false;
    });



// Iconos Botones
    $(function () {
        reactuverButtons()
    });

    function reactuverButtons()
    {
        $("button").button();
        $(".publicado_btn_ui").button({
            icons: {primary: "ui-icon-flag"}, text: false
        })
        $(".no_publicado_btn_ui").button({
            icons: {primary: "ui-icon-alert"}, text: false
        })
        $(".buscar_btn_ui").button({
            icons: {primary: "ui-icon-search"}, text: true
        })
        $(".nuevo_btn_ui").button({
            icons: {primary: "ui-icon-document"}, text: true
        })
        $(".download_btn_ui").button({
            icons: {primary: "ui-icon-circle-arrow-s"}, text: true
        })
        $(".nuevo_btn_ui_icon").button({
            icons: {primary: "ui-icon-circle-plus"}, text: true
        })
        $(".ingresar_btn_ui").button({
            icons: {primary: "ui-icon-folder-open"}, text: false
        })
        $(".editar_btn_ui").button({
            icons: {primary: "ui-icon-pencil"}, text: false
        })
        $(".eliminar_btn_ui").button({
            icons: {primary: "ui-icon-close"}, text: false
        })
        $(".imagenes_btn_ui").button({
            icons: {primary: "ui-icon-image"}, text: false
        })
        $(".productos_btn_ui").button({
            icons: {primary: "ui-icon-tag"}, text: false
        })
        $(".productos_btn_ui").button({
            icons: {primary: "ui-icon-tag"}, text: false
        })
        $(".categorias_btn_ui").button({
            icons: {primary: "ui-icon-bullet"}, text: false
        })
        $(".subcategorias_btn_ui").button({
            icons: {primary: "ui-icon-radio-off"}, text: false
        })
        $(".upload_btn_ui").button({
            icons: {primary: "ui-icon-circle-arrow-n"}, text: true
        })
        $(".upload_btn_ui_poll").button({
            icons: {primary: "ui-icon-circle-arrow-n"}, text: false
        })
        $("#btn_register_cip_menu").button({
            icons: {primary: "ui-icon-disk"}, text: true
        })
        $(".btn_generate_cuestion").button({
            icons: {primary: "ui-icon-gear"}, text: false
        })
        $(".btn_review_cuestion").button({
            icons: {primary: "ui-icon-zoomin"}, text: false
        })
        $(".btn_resolve_cuestion").button({
            icons: {primary: "ui-icon-plus"}, text: false
        })
        $(".btn_stadistics_cuestion").button({
            icons: {primary: "ui-icon-image"}, text: false
        })
        $(".btn_stop_cuestion").button({
            icons: {primary: "ui-icon-stop"}, text: false
        })
        $(".btn_summary_cuestion").button({
            icons: {primary: "ui-icon-zoomin"}, text: false
        })

        $(".btn_print_cuestion").button({
            icons: {primary: "ui-icon-print"}, text: false
        })
        
        $(".btn_print_stadistics").button({
            icons: {primary: "ui-icon-print"}, text: true
        })
        
        $(".btn_link_cuestion").button({
            icons: {primary: "ui-icon-link"}, text: false
        })





    }

// Datepicker
    $(function () {
        $("#datepicker").datepicker({
            showOn: "button",
            dateFormat: "yy-mm-dd",
            buttonImage: "images/skins/skin-1/btn/calendar.gif",
            buttonImageOnly: true,
            maxDate: "+1"
        });
    });

    $(function () {
        $("#datepickerFind").datepicker({
            dateFormat: "yy-mm-dd",
            buttonImageOnly: false,
            maxDate: "+1"
        });
    });


//check
    $(function () {
        $(".check").button();
    });


});

function submitbutton(action)
{
    switch (action)
    {
        case "home":
            gotourl("?gohome=1");
            break;
        case "cache":
            gotourl("?cache=0");
            break;
        case "signout":
            gotourl("?mod=0");
            break;
    }
}

function gotourl(url)
{
    parent.location = url;
}

function gotoModule(mod)
{
    gotourl("?module=" + mod);
}

function reloadpage()
{
    //document.location.reload(true);
    document.location = document.URL;
}

//Constructor del objeto XMLHttpRequest
function getHTTPObject() {
    try {
        objetus = new ActiveXObject("Msxml2.XMLHTTP");
    } catch (e) {
        try {
            objetus = new ActiveXObject("Microsoft.XMLHTTP");
        } catch (E) {
            objetus = false;
        }
    }

    if (!objetus && typeof XMLHttpRequest != 'undefined') {
        objetus = new XMLHttpRequest();
    }

    return objetus
}

//Carga una pagina y la muestra
function ajaxPost(url, valores, inDIV, textoloadin)
{
    var sec = getHTTPObject();
    sec.open("POST", url, true);
    //alert(url);
    sec.onreadystatechange = function () {
        if (sec.readyState == 1)
        {
            if (!textoloadin)
            {
                textoloadin = "Cargando...";
            }


            document.getElementById(inDIV).innerHTML = textoloadin;


        }
        if (sec.readyState == 4)
        {
            if (sec.status == 200)
            {

                document.getElementById(inDIV).innerHTML = sec.responseText;

            } else {
                switch (sec.status) {
                    case 404:
                        alert("404: " + sec.statusText);
                        alert("No se encontró URL");
                        document.getElementById(inDIV).innerHTML = "No se encontró URL";
                        break;
                    case 414:
                        alert("414: " + sec.statusText);
                        alert("Los valores pasados por GET superan los 512");
                        document.getElementById(inDIV).innerHTML = "Los valores pasados por GET superan los 512";
                        break;
                }
            }
        }
    }
    sec.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    sec.send(valores);
}

function changestFree(id, module, table, inDivid)
{
    mode = "TB&table=" + table + "&module=" + module;
    change_status_content(id, mode, inDivid);
}

function changestFree2(id, seccion, module, table, inDivid)
{
    mode = "SecPage&table=" + table + "&module=" + module + "&seccion=" + seccion;
    change_status_content(id, mode, inDivid);
}

function changestFree3(page, seccion, nivel, module, table, inDivid)
{
    mode = "PermisosNivel&table=" + table + "&module=" + module + "&seccion=" + seccion + "&page=" + page + "&nivel=" + nivel;
    change_status_content("", mode, inDivid);
}



function changest(iconte, idimage)
{
    change_status_content(iconte, "ALL", idimage);
}

function changdest(iconte, idimage)
{
    change_status_content(iconte, "DEST", idimage);
}

function change_status_content(id, mode, idimage)
{
    url = SERVER_ADMIN + "modules/mod_admin/ajax/changestatuscontentlang.php";
    valores = "id=" + id + "&mode=" + mode;
    var sec = getHTTPObject();
    sec.open("POST", url, true);
    //alert(url);
    sec.onreadystatechange = function () {
        if (sec.readyState == 1)
        {
            /*cargando*/
        }
        if (sec.readyState == 4)
        {
            if (sec.status == 200)
            {
                //alert(sec.responseText);
                document.getElementById(idimage).innerHTML = sec.responseText;
                $(".publicado_btn_ui").button({
                    icons: {primary: "ui-icon-flag"}, text: false
                })
                $(".no_publicado_btn_ui").button({
                    icons: {primary: "ui-icon-alert"}, text: false
                })
            } else
            {
                /*acurrio algun erro*/
            }
        }
    }
    sec.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    sec.send(valores);
}

//popups emergentes
function emergentesAdm(params, name, myWidth, myHeight, isdialog)
{
    myLeft = (window.screen.width / 2) - (myWidth / 2)
    myTop = (window.screen.height / 2) - (myHeight / 2)

    scrollbars = 1;
    if (window.showModalDialog && isdialog != 1) {
        //myWindow = window.showModalDialog("msgbox.php","name","dialogWidth: "+ myWidth +"px; dialogHeight:124px; center:yes; help:no; scroll:no; status:no");
        myWindow = window.showModalDialog(SERVER_ADMIN + "index.php?emergente=1&dialog=1&" + params, name, "dialogWidth =" + myWidth + "px; dialogHeight =" + myHeight + "px ; center:yes; help:no; scroll:" + scrollbars + "; status:no");
        document.location.reload();

    } else {
        myWindow = window.open(SERVER_ADMIN + "index.php?emergente=1&dialog=0&" + params, name, "width =" + myWidth + ", height =" + myHeight + " , left =" + myLeft + ", top =" + myTop + ", toolbar=0, resizable=0, scrollbars=" + scrollbars + ", status=no, menubar=no")
        myWindow.focus();
    }
}

function roundjs(val, precision) {
    // http://kevin.vanzonneveld.net
    // +   original by: Philip Peterson
    // +    revised by: Onno Marsman
    // *     example 1: round(1241757, -3);
    // *     returns 1: 1242000
    // *     example 2: round(3.6);
    // *     returns 2: 4

    return parseFloat(parseFloat(val).toFixed(precision));
}

$.validator.setDefaults(
    {
        invalidHandler: function ()
        {
            htmlnot = '<div class="message alertmsg"><p>Debes llenar los campos requeridos, revisa las pestañas.</p></div>';
            $("#addmsgalert").html(htmlnot);
            setTimeout('$("#addmsgalert").hide("fade")', 8000);
        }

    }
);

$().ready(function ()
{
    // validate the comment form when it is submitted
    $("#frmadmin").validate(
        {
            errorClass: "input-notification-error",
            validClass: "input-notification-success",
            errorElement: "input-notification-error",
        }
    );
});

function confirmAlertMulUpoad(txt, url)
{
    $("#dialog:ui-dialog").dialog("destroy");
    $("#inDiv_html_delete").html('<span class="ui-icon ui-icon-alert" style="float:left; margin:0 7px 20px 0;"></span>' + txt);
    $("#dialog-confirm-delete").dialog({
        resizable: false,
        //height:140,
        modal: true,
        buttons: {
            "Aceptar": function ()
            {
                $(this).dialog("close");
                if (url == "sub")
                {
                    //parent.location = url;
                    parent.document.frm_cip_product.gotoimg.value = "1";
                    parent.document.frm_cip_product.submit();
                }
            },
        }
    });

    //return false;
}

function alertUIAction(txt) {
    $("#dialog:ui-dialog").dialog("destroy");
    $("#inDiv_html_delete").html('<br><center><img src="' + SERVER_ADMIN + 'images/ajax-loader.gif" /><br>' + txt + '</center>');
    $("#dialog-confirm-delete").dialog({
        resizable: false,
        modal: true,
        width: 300,
        height: 140,
        buttons: {
        },
        title: "Procesando..."
    });
    $(".ui-dialog-buttonpane").hide();
    return false;
}

function alertUI(txt) {
    $("#dialog:ui-dialog").dialog("destroy");
    $("#inDiv_html_delete").html(txt);
    $("#dialog-confirm-delete").dialog({
        resizable: true,
        modal: true,
        width: 300,
        height: 200,
        buttons: {
            "OK": function () {
                $(this).dialog("close");
                return false;
            }
        },
        title: "Alerta"
    });
    return false;
}

function confirmDelete(txt, url) {
    $("#dialog:ui-dialog").dialog("destroy");
    $("#inDiv_html_delete").html('<span class="ui-icon ui-icon-alert" style="float:left; margin:0 7px 20px 0;"></span>' + txt);
    $("#dialog-confirm-delete").dialog({
        resizable: false,
        height: 140,
        modal: true,
        buttons: {
            "Eliminar": function ()
            {
                //$( this ).dialog( "close" );
                $("#inDiv_html_delete").html('<br><center><img src="' + SERVER_ADMIN + 'images/ajax-loader.gif" /></center>');
                $(".ui-dialog-buttonpane").hide();
                setTimeout("gotourl('" + url + "')", 1500);
            },
            "Cancelar": function () {
                $(this).dialog("close");
                return false;
            }
        }
    });
    return false;
}

function mostarlink(pollId) {
    link = SERVER_NAME + "poll/" + pollId + ".html";
    txt = "<b>Link:</b><br><a target=_blank href='" + link + "'>" + link + "</a>";
    $("#dialog:ui-dialog").dialog("destroy");
    $("#inDiv_html_delete").html('<span class="ui-icon ui-icon-link" style="float:left; margin:0 7px 20px 0;"></span>' + txt);
    $("#dialog-confirm-delete").dialog({
        resizable: false,
        height: 140,
        width: 600,
        modal: true,
        buttons: {
        }
    });
}