<?php
class DBIGenerator
{
	
	var $path = "";
	var $path_rais = "";
	
	var $car_path = "DEFAULTPATH";
	
	var $car_modules = "modules";	
	var $car_css = "css";
	var $car_img = "images";
	var $car_js = "js";
	
	
	var $car_src = "src";
	var $car_pages = "pages";
	var $car_library = "library";
	var $car_ajax = "ajax";
	var $car_processor = "processor";
	var $car_templates = "templates";
	
	
	
	var $_DB;
	var $_DB_new;
	
	var $_db_name;
	var $_a_modules;
	var $_a_modules_type;
	
	var $_mod_admin_name = "mod_admin";
	var $_mod_module_name = "mod_modules";
	var $_mod_lang_name = "mod_langs";
	var $_mod_menu_web = "mod_menu";
	var $_mod_about_us = "mod_about_us";
	var $_mod_upload = "mod_upload";
	
	function __construct($DB)
	{
		$this->_DB = $DB;
	}
	
	
	
	function getBDs()
	{
		$rs = $this->_DB->db_query("show databases") or die (mysql_error());
		return $rs;
	}
	
	function connectToNewDB()
	{
		$DB_new = new db($GLOBALS['db_host'],$GLOBALS['db_user'], $GLOBALS['db_password'],$this->_db_name, $GLOBALS['db_persistency']);
		$this->_DB_new = $DB_new;
		return $DB_new;
	}
	
	function connectToDB()
	{
		$DB_normal = new db($GLOBALS['db_host'],$GLOBALS['db_user'], $GLOBALS['db_password'],$GLOBALS['db_name'], $GLOBALS['db_persistency']);
		$this->_DB = $DB_normal;
		return $DB_normal;
	}
	
	function getTables($db)
	{
		$this->connectToDB();
		$rs =  $this->_DB->db_query("show tables from ".$db) or die (mysql_error());
		return $rs;
	}
	
	function crearDirectorio($P)
	{
		if(@mkdir($P)){
			chmod($P, 0777);
		}else
		{
			//echo $P;
		}
	}
	
	function getModuleCode($nod_name)
	{
		return "mod_". str_replace(" ","_",strtolower($nod_name));
	}
	
	function  createStructure()
	{
		$this->createStructureSite();
		foreach($this->_a_modules as $mod_mane => $mod_tables)
		{
			$this->createStructureModule($this->getModuleCode($mod_mane));
		}
	}
	
	function createStructureModule($mod_name)
	{
		$patach_module = $this->path.$this->car_modules."/".$mod_name."/";		
		//echo $patach_module."<br>";
		$this->crearDirectorio($patach_module);
		$this->crearDirectorio($patach_module.$this->car_ajax."/");
		$this->crearDirectorio($patach_module.$this->car_library."/");
		$this->crearDirectorio($patach_module.$this->car_pages."/");
		$this->crearDirectorio($patach_module.$this->car_processor."/");
		$this->crearDirectorio($patach_module.$this->car_src."/");
		$this->crearDirectorio($patach_module.$this->car_templates."/");
	}
	
	
	
	function createStructureSite()
	{
		$this->crearDirectorio($this->path);
		
		$this->smartCopy($this->path_rais."body-seccion.php",$this->path."body-seccion.php");
		$this->smartCopy($this->path_rais."cuerpo.php",$this->path."cuerpo.php");
		$this->smartCopy($this->path_rais."header-seccion.php",$this->path."header-seccion.php");
		$this->smartCopy($this->path_rais."index.php",$this->path."index.php");
		$this->smartCopy($this->path_rais."init.php",$this->path."init.php");
		$this->smartCopy($this->path_rais."login.php",$this->path."login.php");
		$this->smartCopy($this->path_rais."panel.php",$this->path."panel.php");
		$this->smartCopy($this->path_rais."router.php",$this->path."router.php");
		$this->createSettings();
		
		
		//$this->crearDirectorio($this->path.$this->car_css."/");
		$this->smartCopy($this->path_rais.$this->car_css,$this->path.$this->car_css);
		$this->smartCopy($this->path_rais.$this->car_img,$this->path.$this->car_img);
		$this->smartCopy($this->path_rais.$this->car_js,$this->path.$this->car_js);
		$this->smartCopy($this->path_rais.$this->car_library,$this->path.$this->car_library);
		$this->smartCopy($this->path_rais.$this->car_src,$this->path.$this->car_src);
		
		$this->crearDirectorio($this->path.$this->car_modules."/");
		
		$this->smartCopy($this->path_rais.$this->car_modules."/".$this->_mod_admin_name,$this->path.$this->car_modules."/".$this->_mod_admin_name);
		$this->smartCopy($this->path_rais.$this->car_modules."/".$this->_mod_module_name,$this->path.$this->car_modules."/".$this->_mod_module_name);
		$this->smartCopy($this->path_rais.$this->car_modules."/".$this->_mod_lang_name,$this->path.$this->car_modules."/".$this->_mod_lang_name);
		$this->smartCopy($this->path_rais.$this->car_modules."/".$this->_mod_menu_web,$this->path.$this->car_modules."/".$this->_mod_menu_web);
		$this->smartCopy($this->path_rais.$this->car_modules."/".$this->_mod_about_us,$this->path.$this->car_modules."/".$this->_mod_about_us);
		$this->smartCopy($this->path_rais.$this->car_modules."/".$this->_mod_upload,$this->path.$this->car_modules."/".$this->_mod_upload);
		
		
	}
	
	function createSettings()
	{
		$txt_file = "<?php
		\$db_host 		= 'localhost';
		\$db_user 		= 'root';
		\$db_password 		= 'mysql';
		\$db_name 		= '".$this->_db_name."';
		\$db_persistency 	= false;
		?>";
		$this->saveFile($this->path."settings.php",$txt_file);
	}
	
	
	function saveFile($patch_save,$txt_file)
	{
		$fp=fopen($patch_save,'w') or die('Failed opening file');
		fwrite($fp,$txt_file);
		fclose($fp);
	}
	
	/*
	* genera los scripts para seguimiento de auditoria
	*/
	function crear_script_seguimiento_auditoria($db_name,$tables)
	{
		$this->_db_name = $db_name;	
		$this->connectToNewDB();	
		$this->path = PATH_MODULE.$this->car_path."/".$this->_db_name."/";
		$this->path_rais = PATH_ADMIN;		
		$this->crearDirectorio($this->path);
		
		if(is_array($tables))
		{
			$all_scripts = "";
			foreach($tables as  $table_name)
			{
				$file_to_save = $this->path.$table_name.".sql";
				$sql_save = "CREATE TABLE auditoria_".$table_name." (
				audit_id_".substr($table_name,0,10)." INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
				  usuario varchar(100) NOT NULL,
				  fecha datetime NOT NULL
				";
				$info_table = $this->_DB_new->db_dscTable($table_name);
				//var_dump($info_table);		exit;
				$text_campos = "";
				$text_valores = "";
				foreach($info_table as $val_column_name => $val_column_value)
				{
					if($val_column_value['notnull'])
					{
						$val_column_value['notnull'] = "NOT NULL";
					}else
					{
						$val_column_value['notnull'] = "NULL";
					}
					
					if($val_column_value['default'] != "")
					{
						$val_column_value['default'] = "DEFAULT '".$val_column_value['default']."'";
					}else
					{
						$val_column_value['default'] = "";
					}
					
					$sql_save .= ",
					".$val_column_name."_old  ".$val_column_value['type']." ".$val_column_value['notnull']." ".$val_column_value['default'];
					$sql_save .= ",
					".$val_column_name."_new  ".$val_column_value['type']." ".$val_column_value['notnull']." ".$val_column_value['default'];
					
					$text_campos .= ", ".$val_column_name."_old";
					$text_campos .= ", ".$val_column_name."_new";
					
					$text_valores .= ", OLD.".$val_column_name;
					$text_valores .= ", NEW.".$val_column_name;
					
				}
				$sql_save .= ",
				 PRIMARY KEY(audit_id_".substr($table_name,0,10).") );
				 				 
				 DELIMITER //
				CREATE TRIGGER `tg_auditoria_".$table_name."` AFTER UPDATE ON `".$table_name."` FOR EACH ROW BEGIN
				INSERT INTO auditoria_".$table_name."
				 (
				 	usuario,fecha ".$text_campos."
				 )VALUES
				 (
				 	CURRENT_USER(), NOW() ".$text_valores."
				 ); END//
				 DELIMITER ;
				 ";
				 
				 $all_scripts .= $sql_save;
				 /*GENERANDO TIGGER*/
				 
				 
				$this->saveFile($file_to_save,$sql_save);
			}
			
			$file_to_save = $this->path.$db_name."_all.sql";
			$this->saveFile($file_to_save,$all_scripts);
		}
		
	}
	
	/*
	* @a_modules arra con modulos y en cada modulo la tabla k le corresponde
	*/
	
	function generate($db_name, $a_modules)
	{
		
		$this->_db_name = $db_name;
		$this->_a_modules = $a_modules;
		$this->path = PATH_MODULE.$this->car_path."/".$this->_db_name."/";
		$this->path_rais = PATH_ADMIN;
		
		//_a_modules_type
		foreach($this->_a_modules as $mod_mane => $mod_tables)
		{
			$this->_a_modules_type[$mod_mane] = $mod_tables["type"];
			unset($mod_tables["type"]);
			$this->_a_modules[$mod_mane] = $mod_tables;
		}
		
		//var_dump($this->_a_modules); exit;
		
		/*pretarando directorios*/
		$this->prepareDataBase();
		$this->createStructure();
		$this->createScripts();
	}
	
	function prepareDataBase()
	{
		$this->connectToNewDB();
		$sql_def = "";
		$lines = file(PATH_ADMIN."db/default.sql");
		for($i=0;$i<count($lines);$i++){
			$sql_def .= $lines[$i];
		}
		
		$a_queryes = explode(";",$sql_def);
		
		foreach($a_queryes as $sql_to_prepare)
		{
			//var_dump($valuedddd);
			$this->_DB_new->db_query($sql_to_prepare);
		}

		
		
		
	}
	
	
	
	function createScripts()
	{
		foreach($this->_a_modules as $mod_mane => $mod_tables)
		{
			$this->generateCodeToSave($mod_mane,$mod_tables);
			
		}
	}
	
	function generateCodeToSave($mod_mane,$mod_tables)
	{
		/*generando procesador*/
		$id_module_db = $this->GenerateFilesIniModule($mod_mane,$mod_tables);
		
		foreach($mod_tables as $table_name)
		{
			$this->GenerateSrc($mod_mane,$table_name);
			$this->GenerateProcessor($mod_mane,$table_name);
			$this->GenerateTemplates($mod_mane,$table_name);
			$this->GeneratePages($mod_mane,$table_name);
			
		}
		
	}
	
	function GenerateTemplates($mod_mane,$table_name)
	{
		$is_genera_to_lang = $this->_a_modules_type[$mod_mane];
		
		$module_code = $this->getModuleCode($mod_mane);
		$info_table = $this->_DB_new->db_dscTable($table_name);
		
		$add_txt_to_list_header = "";
		$add_txt_to_list_body = "";
		
		$add_txt_to_form = "";
		
		$primari_key = "";
		foreach($info_table as $val_column_name => $val_column_value)
		{			
			if($val_column_value['primary'])
			{
				$primari_key = $val_column_value['name'];
				
			}
		}
		reset($info_table);
		
		foreach($info_table as $val_column_name => $val_column_value)
		{
			switch($val_column_value['name'])
			{
				case "cl_order":
					$add_txt_to_list_header .= '
					<th><a class="sort" href="?fl='.$val_column_value['name'].'&ord={ord}">Órden</a></th>';
					
					$add_txt_to_list_body .= '
					<td>{cl_order} {add_op_order}</td>';
					break;
				case "cl_status":
					$add_txt_to_list_header .= '
					<th><a class="sort" href="?fl='.$val_column_value['name'].'&ord={ord}">Estado</a></th>';
					
					/*$add_txt_to_list_body .= '
					<td><a href="javascript:changestFree(\'{'.$primari_key.'}\',\'img_status_change_{'.$primari_key.'}\',\'TB|'.$table_name.'|'.$module_code.'\');"><img src="{SERVER_ADMIN}images/icons/{cl_status}" id="img_status_change_{'.$primari_key.'}" border=0 /></a></td>';*/
					
					$add_txt_to_list_body .= '
					<td>{cl_status}</td>';
					
					break;
				default:
					$add_txt_to_list_header .= '
					<th><a class="sort" href="?fl='.$val_column_value['name'].'&ord={ord}">'.$val_column_value['name'].'</a></th>';
					
					$add_txt_to_list_body .= '
					<td >{'.$val_column_value['name'].'}</td>';
			}
			
			
			
			
			$is_rrequired = "";
			if($val_column_value['Null'] != "YES")
			{
				$is_rrequired = "required";
			}
			
			$html_row_in_add_txt_to_form = "";
			//var_dump($val_column_value); exit;
			@list($adddd, $bdd) = split( '[(]', $val_column_value['type']);
			$tipo_columna = $adddd;
			$num_max = substr($bdd,0,strpos($bdd,")"));
			//var_dump($num_max); exit;
			$cap = 0;
			//echo $tipo_columna; exit;
			$tipo_validacioln_js = "ANY";
			//echo $tipo_columna."<br>";
			$add_name_f_land = "";
			if($is_genera_to_lang == "1")
			{
				$add_name_f_land = "_{l_id}";
			}
				
			switch($tipo_columna)
			{
				case "int":
				case "double":
				case "numeric":
					$tipo_validacioln_js = "I";
					$html_row_in_add_txt_to_form = '<input name="txt_'.$val_column_value['name'].$add_name_f_land.'"  type="text" class="text medium-input '.$is_rrequired.' number" id="txt_'.$val_column_value['name'].$add_name_f_land.'" size="'.$num_max.'" maxlength="'.$num_max.'" value="{'.$val_column_value['name'].'}" />';
					break;
				case "datetime":
				case "date":
					$html_row_in_add_txt_to_form = '<input  name="txt_'.$val_column_value['name'].$add_name_f_land.'" type="text" class="text medium-input '.$is_rrequired.' date" id="datepicker" size="10" maxlength="10" value="{'.$val_column_value['name'].'}" READONLY />';
					
					if($cap == 0)
					{
						$cap = 1;
					}
					break;
				case "tinytext":
				case "text":
					$html_row_in_add_txt_to_form = '
					<textarea class="text-input textarea  '.$is_rrequired.'" name="txt_'.$val_column_value['name'].$add_name_f_land.'"  id="txt_'.$val_column_value['name'].$add_name_f_land.'" >{'.$val_column_value['name'].'}</textarea>
					';
					break;
				default:
					/*txt*/
					$html_row_in_add_txt_to_form = '<input name="txt_'.$val_column_value['name'].$add_name_f_land.'"  type="text" class="text medium-input '.$is_rrequired.'" id="txt_'.$val_column_value['name'].$add_name_f_land.'" size="'.$num_max.'" maxlength="'.$num_max.'" value="{'.$val_column_value['name'].'}" />';
				
			}
			$add_txt_to_form .= '
			<p>
				<label>'.$val_column_value['name'].'</label>
				'.$html_row_in_add_txt_to_form.'
				<small></small>
			</p>
			<br>
			';
			
			if($val_column_value['primary'])
			{
				$primari_key = $val_column_value['name'];
			}
			
			
		}
		
		if($is_genera_to_lang == "1")
		{
			$add_txt_to_list_header = '
				<th><a class="sort" href="?fl=c_id&ord={ord}">c_id</a></th>
				<th><a class="sort" href="?fl=l_id&ord={ord}">l_id</a></th>
				<th><a class="sort" href="?fl=cl_name&ord={ord}">Título</a></th>
				<th><a class="sort" href="?fl=cl_description&ord={ord}">Descripción</a></th>
				<th><a class="sort" href="?fl=cl_order&ord={ord}">Órden</a></th>
				<th width="100px"><a class="sort" href="?fl=cl_status&ord={ord}">Estado</a></th>
				
			'.$add_txt_to_list_header;
			
			$add_txt_to_list_body = '
				<td>{c_id}</td>
				<td>{l_id}</td>
				<td>{cl_name}</td>
				<td>{cl_description}</td>
				<td>{cl_order} {add_op_order}</td>
				<td>{cl_status}</td>
			'.$add_txt_to_list_body;
			$primari_key = "c_id";
		}
		
		
		/*generando list php*/
		$txt_page_list_html = '<!-- inicioBloque: list_'.$table_name.' -->
		<script>
		function uporder(cl_c_id)
		{
			document.location = "{SERVER_ADMIN}?module={MODULE}&mod={mod}&ID="+cl_c_id+"&'.$table_name.'=up";
		}
		function downorder(cl_c_id)
		{
			document.location = "{SERVER_ADMIN}?module={MODULE}&mod={mod}&ID="+cl_c_id+"&'.$table_name.'=dw";
		}
		</script>
		<!--<h3>{title}</h3>-->		
		<div class="mod-content">
		<div id="tabs">
			<ul>
			  <li><a href="#tabs-1">{title}</a></li>
			</ul>
			<div id="tabs-1">
			<div id="addmsgalert"></div>
			{mensaje_alerta}
		  	<div class="tabla-top-bar"> {simple_search}
        {options_header} </div>
		  
				<form name="formlist" method="post" action="">
      			<input type="hidden" name="action" value="" />
	  	 		<table>
					<thead>
						<tr>
						  <th width="10px"><input class="check-all" type="checkbox" /></th>
						  '.$add_txt_to_list_header.'
						  <th width="120px">Acciones</th>
						</tr>
					</thead>					
					<tbody>
					{FILAS}
						<!-- inicioBloque: tFila -->
						<tr>
						  	<td align="center"><input lang="1|'.$table_name.'|ANY" type="checkbox" id="for_id_anun_{'.$primari_key.'}" name="c_file[]" value="{'.$primari_key.'}" />
						  	'.$add_txt_to_list_body.'
						  	<td align="center">
								<a href="{basic_url_get}&'.$table_name.'=edit&ID={'.$primari_key.'}" class="editar_btn_ui"  title="Editar"  >Editar</a>
								<a href="javascript:;" class="eliminar_btn_ui" onclick="return confirmDelete(\'¿Estás seguro de eliminar a : {'.$primari_key.'}?\',\'{basic_url_get}&'.$table_name.'=del&ID={'.$primari_key.'}\')" title="Eliminar">Eliminar</a>
							</td>
						</tr>
						<!-- finBloque: tFila -->
					</tbody>
			  </table>
			</form>
			<div class="tabla-bottom-bar">
				<div class="accion">{html_actions_footer}</div>
				{html_numero_paginas}
				<div class="paginacion">{pbar_show_npages}</div>
			  </div>
		  </div>
		</div>
		</div>
		<!-- finBloque: list_'.$table_name.' -->
		';
		$this->saveFile($this->path.$this->car_modules."/".$module_code."/".$this->car_templates."/list_".$table_name.".html",$txt_page_list_html);
		
		if($is_genera_to_lang == "1")
		{
			$complete_add_txt_to_form = '
			<div id="addmsgalert"></div>
			{FILAS}
				<!-- inicioBloque: tFila -->
				<!-- INICIO DE LA TABLA DEFAULT -->				
				<div id="tabs-{l_id}">
				
				{mensaje_alerta} {options_header}
				<p>
				  <label>Título</label>
				  <input name="txt_cl_name_{l_id}"  type="text" class="text medium-input required" id="txt_cl_name_{l_id}"  maxlength="32" value="{cl_name}" />
				  <small></small>
				</p>
				<br>
				<p>
				  <label>Álias</label>
				  <input name="txt_cl_name_id_{l_id}"  type="text" class="text medium-input" id="txt_cl_name_id_{l_id}"  maxlength="32" value="{cl_name_id}" />
				  <small></small>
				</p>
				<br>
				<p>
				  <label>Descripción</label>
				  <textarea class="text-input textarea  required" id="txt_cl_description_{l_id}" name="txt_cl_description_{l_id}" >{cl_description}</textarea>
				  <small></small>
				</p>
				<br>				
				'.$add_txt_to_form.'
				
				<p>
					<button title="Enviar" name="btn_register_'.$table_name.'" id="btn_register_'.$table_name.'" type="submit">Guardar</button>
				  
				</p>
				</div>
				<!-- finBloque: tFila -->
			';
			$def_tab_bef = '';
			$def_tab_end = '';
		}else
		{
			$def_tab_bef = '<ul>
      <li><a href="#tabs-1">{title}</a></li>
    </ul>
    <div id="tabs-1"> {mensaje_alerta} {options_header}';
			$def_tab_end = '</div>';
			$complete_add_txt_to_form = $add_txt_to_form.'
			<p>
			 <button title="Enviar" name="btn_register_'.$table_name.'" id="btn_register_'.$table_name.'" type="submit">Guardar</button>
			</p>
			';
		}
		
		
		/*creando form html*/
		$txt_page_form_html = '
		<!-- inicioBloque: frm_'.$table_name.' -->
		<!--<h3>{title}</h3>-->		  		  
	    
		<div class="mod-content">
		<div id="tabs">
			
      		{htmltabshea}
    		'.$def_tab_bef.'
		 
		 
		  <form name = "frm_'.$table_name.'" id="frmadmin" action = "" METHOD="POST">
			<input type="hidden" name="mod" value="{mod}" />
			<input type="hidden" name="ID" value="{ID}" />
			<input type="hidden" name="action" value="{'.$table_name.'}" />
			<input type="hidden" name="btn_register_'.$table_name.'" value="" />
			
			'.$complete_add_txt_to_form.'
			
			
			
			
			
		  </form>
		</div>
		</div>
		'.$def_tab_end.'
		<!-- finBloque: frm_'.$table_name.' -->
		';
		$this->saveFile($this->path.$this->car_modules."/".$module_code."/".$this->car_templates."/form_".$table_name.".html",$txt_page_form_html);
	}
	
	function GeneratePages($mod_mane,$table_name)
	{
		$is_genera_to_lang = $this->_a_modules_type[$mod_mane];
		
		$module_code = $this->getModuleCode($mod_mane);		
		$info_table = $this->_DB_new->db_dscTable($table_name);
		
		$primari_key = "";
		
		$add_text_fun = "";
		$add_txt_to_from = "";
		foreach($info_table as $val_column_name => $val_column_value)
		{
			$add_text_fun .= '
					$search->add_column_search("'.$val_column_value['name'].'", "'.$val_column_value['name'].'","'.$table_name.'");
					';
			$add_txt_to_from .= '
			$tpl->assign("'.$val_column_value['name'].'", @$ob_'.$table_name.'->'.$val_column_value['name'].');';
			if($val_column_value['primary'])
			{
				$primari_key = $val_column_value['name'];
			}
		}
		
		/*generando list php*/
		$txt_list_page_php = '<?php
		$ob_'.$table_name.' = @$GLOBALS["ob_'.$table_name.'"];
		$tpl = $GLOBALS[\'tpl\'];
		$tpl->load("template", "list_'.$table_name.'.html");
		$tpl->set_block("list_'.$table_name.'", "template");
		
		$tpl->assign("title", "Lista de '.$table_name.'");
		
		$ob_page_options = new pageoptions();		
		$ob_page_options->addOption("Nuevo",$GLOBALS[\'basic_url_get\']."&'.$table_name.'=new","nuevo");		
		$tpl->assign("options_header", $ob_page_options->getPageOptions());
		
		';
		
		if($is_genera_to_lang == "1")
		{
			$txt_list_page_php .= '
			/*definiendo valores a ordenes 0*/
			$sql_ord = $ob_'.$table_name.'->getSQL("","",",cl_order")." and cl_order = 0";
			$rs_ord = $GLOBALS[\'DB\']->db_query($sql_ord);
			while($row_ord = $ob_'.$table_name.'->nextrow($rs_ord))
			{
				$ob_'.$table_name.'->setOrder($row_ord[\'cl_c_id\']);
			}
			
			/***********************************************************/
			
			$sql = $ob_'.$table_name.'->getSQL();
		
			$sql .= " [simple_search_w]
				[simple_search_h] ";
		
		
			if(!isset($_GET["fl"])) $_GET["fl"] = "ra_content_lang.cl_order";
			';
		}else
		{
			$txt_list_page_php .= '			
			/*definiendo valores a ordenes 0*/
			/*
			$rs_ord = $ob_'.$table_name.'->getAll(\'cl_order = 0\');			
			while($row_ord = $ob_'.$table_name.'->nextrow($rs_ord))
			{
				$ob_'.$table_name.'->setOrder($row_ord[\''.$primari_key.'\']);
			}
			*/
			/************************************************************/
			
			$sql = "SELECT * FROM '.$table_name.'
					[simple_search_w]
					[simple_search_h] ";
					
			if(!isset($_GET["fl"])) $_GET["fl"] = "'.$primari_key.'";
			//if(!isset($_GET["fl"])) $_GET["fl"] = "cl_order";
			';
		}
		
		
		
			
		
		$txt_list_page_php .= '
			/*if(!isset($_GET["ord"]))
			{
				$_GET["ord"] = "DESC";
				$vord = "ASC";
			} elseif($_GET["ord"] == "DESC") {
				$vord = "ASC";
			} else {
				$vord = "DESC";
			}*/
			
			if(!isset($_GET["ord"]))
			{
				$_GET["ord"] = "ASC";
				$vord = "DESC";
			} elseif($_GET["ord"] == "ASC") {
				$vord = "DESC";
			} else {
				$vord = "ASC";
			}
			$sql .= " ORDER BY ".$_GET["fl"]." ".$_GET["ord"];
			
			//Busqueda simple
			$search = new simple_search($GLOBALS[\'DB\']);
			';
			
			if($is_genera_to_lang == 1)
			{
				$txt_list_page_php .= '
				$search->add_column_search("Título", "cl_name","ra_content_lang");				
				$search->add_column_search("Descripción", "cl_description","ra_content_lang");
				
				
				';
			}
			
			
			
			$txt_list_page_php .= '
			'.$add_text_fun.'
			
				
			$search->get_sql($sql);
			$tpl->assign("simple_search", $search->get_str());
			
			//Paginacion
			if(!isset($_GET["nr"])){ $_GET["nr"] = 20; }

			$pbar = new pagbar($GLOBALS[\'DB\']);
			$pbar->pb_limit ($_GET["nr"]);
			$pbar->pb_nlinks(7);
			$pbar->pb_sql($sql);
			
			//Tabla template
			$table_template = new table_template();
			
			$GLOBALS[\'num_results\'] = $pbar->_total_reg;
			$GLOBALS[\'contador_ord\'] = 1;
			
			function get_param_fil($i, $fil)
			{
				$param["offset"] = $i - 1;
				';
				
				if($is_genera_to_lang == 1)
				{
					$txt_list_page_php .= '
					$param[\'cl_status\'] = getStatusDefinive($fil[\'cl_status\'],$_GET[\'module\'],$GLOBALS[\'ob_'.$table_name.'\']->_table,$fil[\''.$primari_key.'\']);
					
					
					$add_op_order = \'\';				
					/*calculando opcioes para orden*/
					if($fil[\'cl_order\'] > 1)
					{
						/*Nuestra subir orden (4 - 3)*/
						$add_op_order .= "<a href=\\"javascript:uporder(\'".$fil[\'c_id\']."\');\\"><img src=\\"".SERVER_IMG_ADMIN."btn/up.png \\" border=\\"0\\" /></a>";
					}else
					{
						$add_op_order .= \'<img src="\'.SERVER_IMG_ADMIN.\'btn/up_b.png" border="0" />\';
					}
					
					if($fil[\'cl_order\'] < $GLOBALS[\'num_results\'])
					{
						/*muestra bajar orden (3 -> 4)*/
						$add_op_order .= "<a href=\\"javascript:downorder(\'".$fil[\'c_id\']."\');\\"><img src=\\" ".SERVER_IMG_ADMIN."btn/down.png \\" border=\\"0\\" /></a>";
					}else
					{
						$add_op_order .= \'<img src="\'.SERVER_IMG_ADMIN.\'btn/down_b.png" border="0" />\';
					}
					
					$GLOBALS[\'contador_ord\']++;
					$param["add_op_order"] = $add_op_order;
					';
				}else
				{
					$txt_list_page_php .= '
					/*
					$param[\'cl_status\'] = getStatusDefinive($fil[\'cl_status\'],$_GET[\'module\'],$GLOBALS[\'ob_'.$table_name.'\']->_table,$fil[\''.$primari_key.'\']);
					
					$add_op_order = \'\';				
					/*calculando opcioes para orden*/
					if($fil[\'cl_order\'] > 1)
					{
						//Nuestra subir orden (4 - 3)
						$add_op_order .= "<a href=\\"javascript:uporder(\'".$fil[\''.$primari_key.'\']."\');\\"><img src=\\" ".SERVER_IMG_ADMIN."btn/up.png \\"  border=\\"0\\" /></a>";
					}else
					{
						$add_op_order .= \'<img src="\'.SERVER_IMG_ADMIN.\'btn/up_b.png" border="0" />\';
					}
					
					if($fil[\'cl_order\'] < $GLOBALS[\'num_results\'])
					{
						//muestra bajar orden (3 -> 4)
						$add_op_order .= "<a href=\\"javascript:downorder(\'".$fil[\''.$primari_key.'\']."\');\\"><img src=\\" ".SERVER_IMG_ADMIN."btn/down.png \\"  border=\\"0\\" /></a>";
					}else
					{
						$add_op_order .= \'<img src="\'.SERVER_IMG_ADMIN.\'btn/down_b.png" border="0" />\';
					}
					
					$GLOBALS[\'contador_ord\']++;
					$param["add_op_order"] = $add_op_order;
					*/
					';
				}
				
				$txt_list_page_php .= '
				return $param;
			}
			
			$table_template->set_tpl($tpl);
			$table_template->load_result($pbar->sql_result(), $GLOBALS[\'DB\']);
			$table_template->open();
			
			$table_template->assign("ord", $vord.$GLOBALS["gv2"]);
			$table_template->assign("modulo", $_GET["mod"]);
			//$table_template->assign("sql", urlencode($sql));
			$table_template->load_fil();
			
			$tpl->assign("pbar_show_npages", $pbar->pb_str_show_npages());
			//$tpl->assign("pbar_show_info", $pbar->pb_str_show_info());
			$tpl->assign("html_numero_paginas", html_numero_paginas());
			$tpl->show("list_'.$table_name.'");
			
		?>';
		$this->saveFile($this->path.$this->car_modules."/".$module_code."/".$this->car_pages."/list_".$table_name.".php",$txt_list_page_php);
		
		/*generando form.php*/
		
		$txt_form_php = '<?php
		$ob_'.$table_name.' = @$GLOBALS["ob_'.$table_name.'"];
		$tpl = $GLOBALS[\'tpl\'];
		$tpl->load("template", "form_'.$table_name.'.html");
		$tpl->set_block("frm_'.$table_name.'", "template");
		
		$tpl->assign("mod", @$_GET["mod"]);
		$tpl->assign("ID", @$_GET["ID"]);			
		$tpl->assign("'.$table_name.'", @$_GET["'.$table_name.'"]);
		
		$title_name = "Nuevo '.$table_name.'";
		
		if($_GET[\''.$table_name.'\'] == "edit")
		{
			$title_name = "Editar '.$table_name.'";
		}
		
		$tpl->assign("title", "$title_name");
		';
		if($is_genera_to_lang == "1")
		{
			$txt_form_php .= '
			
			$GLOBALS[\'htmltabshea\'] = \'<ul>\';
			
			/*cargar por idiomas*/	
			$rs_langs = getLangs();
			
			function func_lang($i, $fil)
			{
				$param = array();
				
				
				$GLOBALS[\'ob_'.$table_name.'\']->getRowByLang($_GET[\'ID\'],$fil[\'l_id\']);
				
				$GLOBALS[\'tpl\']->assign("ob_'.$table_name.'",$GLOBALS[\'ob_'.$table_name.'\']);
				$GLOBALS[\'tpl\']->assign("ra_content_lang",$GLOBALS[\'ob_'.$table_name.'\']->ra_content_lang);
								
				$param["l_id"] = $fil[\'l_id\'];
				
				$add_t = "";
				if($i == 1)
				{
					$add_t = "default-tab";					
				}
				
				$param["setdef_tab_cont"] = $add_t;
				
				$GLOBALS[\'htmltabshea\'] .= \'<li><a href="#tabs-\'.$fil[\'l_id\'].\'">\'.$fil[\'l_name\'].\'</a></li>\';
				
				return $param;
			}
			
			$table_template = new table_template();
			$table_template->functione = "func_lang";
			$table_template->set_tpl($tpl);
			$table_template->load_result($rs_langs, $GLOBALS[\'DB\']);
			$table_template->open();	
			$table_template->load_fil();
			
			$GLOBALS[\'htmltabshea\'] .= \'</ul>\';
			$tpl->assign("htmltabshea", $GLOBALS[\'htmltabshea\']);
			
			';
		}else
		{
			$txt_form_php .= '
			$tpl->assign("ob_'.$table_name.'", $ob_'.$table_name.');
			';
		}
		
		
		$txt_form_php .= '		
		$tpl->show("frm_'.$table_name.'");
		?>
		';
		$this->saveFile($this->path.$this->car_modules."/".$module_code."/".$this->car_pages."/form_".$table_name.".php",$txt_form_php);
	}
	
	function GenerateProcessor($mod_mane,$table_name)
	{
		$is_genera_to_lang = $this->_a_modules_type[$mod_mane];
		$module_code = $this->getModuleCode($mod_mane);
		
		$add_ddd = "";
		if($is_genera_to_lang == "1")
		{
			$add_ddd = "//";
		}
		
		$txt_processor = '<?php
		
		$ob_'.$table_name.' = newClassMod(\''.$table_name.'\');
		
		switch($_GET[\''.$table_name.'\'])
		{
			
			case "new":
				$page_tal = PATH_MODULE."pages/form_'.$table_name.'.php";
				break;
			case "edit":
				'.$add_ddd.'$ob_'.$table_name.'->getRow($_GET[\'ID\']);
				$page_tal = PATH_MODULE."pages/form_'.$table_name.'.php";
				break;';
			if($is_genera_to_lang == "1")
			{	
			$txt_processor .= '
			case "up":
				$ob_'.$table_name.'->getRowByLang($_GET[\'ID\'],LANG);
				$cur_ord = $ob_'.$table_name.'->ra_content_lang->cl_order;
				$id_cu_or = $ob_'.$table_name.'->getIDFromOrder($cur_ord-1);
				$ob_'.$table_name.'->setOrder($_GET[\'ID\'],$cur_ord-1);
				$ob_'.$table_name.'->setOrder($id_cu_or,$cur_ord);
				$where_go = "raiz";
				break;
			case "dw":
				$ob_'.$table_name.'->getRowByLang($_GET[\'ID\'],LANG);
				$cur_ord = $ob_'.$table_name.'->ra_content_lang->cl_order;
				$id_cu_or = $ob_'.$table_name.'->getIDFromOrder($cur_ord+1);
				$ob_'.$table_name.'->setOrder($_GET[\'ID\'],$cur_ord+1);
				$ob_'.$table_name.'->setOrder($id_cu_or,$cur_ord);
				$where_go = "raiz";
				break;';
			}else
			{
			$txt_processor .= '
			case "up":
				$ob_'.$table_name.'->getRow($_GET[\'ID\']);
				$cur_ord = $ob_'.$table_name.'->cl_order;
				$id_cu_or = $ob_'.$table_name.'->getIDFromOrder($cur_ord-1);
				$ob_'.$table_name.'->setOrder($_GET[\'ID\'],$cur_ord-1);
				$ob_'.$table_name.'->setOrder($id_cu_or,$cur_ord);
				$where_go = "raiz";
				break;
			case "dw":
				$ob_'.$table_name.'->getRow($_GET[\'ID\']);
				$cur_ord = $ob_'.$table_name.'->cl_order;
				$id_cu_or = $ob_'.$table_name.'->getIDFromOrder($cur_ord+1);
				$ob_'.$table_name.'->setOrder($_GET[\'ID\'],$cur_ord+1);
				$ob_'.$table_name.'->setOrder($id_cu_or,$cur_ord);
				$where_go = "raiz";
				break;';
			}
			$txt_processor .= '
			case "del":
				if($ob_'.$table_name.'->doDelete($_GET[\'ID\']))
				{
					$_SESSION[\'SES_TYPEMSG\'] = "ok";
					$_SESSION[\'SES_MSGBOX\'] = "Eliminado correctamente";
				}else
				{
					$_SESSION[\'SES_TYPEMSG\'] = "error";
					$_SESSION[\'SES_MSGBOX\'] = "Error al intentar eliminar.";
				}
				$where_go = "raiz";
				break;
			
			default:
				$page_tal = PATH_MODULE."pages/list_'.$table_name.'.php";
		}
		
		if(isset($_POST[\'action\']))
		{
			';
			
			if($is_genera_to_lang == "1")
			{
				
			}else
			{
				$txt_processor .= ' $ob_'.$table_name.'->GetValsForm($_POST);';
			}	
					
			$txt_processor .= '
			
			$where_go = "";
			switch(@$_POST[\'action\'])
			{
				';
				
				if($is_genera_to_lang == "1")
				{
					$txt_processor .= '
					case "new":
					case "edit":
						if($ob_'.$table_name.'->GetValsForm($_POST,$_GET[\'ID\']))
						{
							$TYPEMSG = "ok";
							$MSGBOX = "Datos guardados correctamente";	
							$where_go = "raiz";
						}else
						{
							$TYPEMSG = "warning";
							$MSGBOX = "Error en guardar datos";
							$where_go = "page";
						}
						break;
					
					';
				}else
				{
				$txt_processor .= '
				case "new":
					if($ob_'.$table_name.'->doInsert())
					{	
						$TYPEMSG = "ok";
						$MSGBOX = "Datos guardados correctamente";	
						$where_go = "raiz";
					}else{
						$TYPEMSG = "warning";
						$MSGBOX = "Error en guardar datos";
						$where_go = "page";
					}
					break;
				case "edit":
					if($ob_'.$table_name.'->doUpdate())
					{
						$TYPEMSG = "ok";
						$MSGBOX = "Datos Actualizados correctamente";
						$where_go = "raiz";
					}else{
						$TYPEMSG = "warning";
						$MSGBOX = "Error en Actualizar datos";
						$where_go = "page";
					}
					break;
				';
				}
				$txt_processor .= '
				case "masdel":			
					if(is_array($_POST[\'c_file\']))
					{
						foreach($_POST[\'c_file\'] as $de_id => $del_value_id)
						{
							$ob_'.$table_name.'->doDelete($del_value_id);
						}
					}
					
					$TYPEMSG = "ok";
					$MSGBOX = "Los items fueron eliminado correctamente.";
					$where_go = "raiz";
					break;
			}
			
			$_SESSION[\'SES_TYPEMSG\'] = $TYPEMSG;
			$_SESSION[\'SES_MSGBOX\'] = $MSGBOX;
			
			
		}
		
		/*haciendo header a raiz*/
		switch($where_go)
		{
			case "raiz":
				actionHeader($GLOBALS[\'basic_url_get\']);
				break;
			case "page":
				actionHeader( "?".$_SERVER[\'QUERY_STRING\']  );
				break;		
		}
		
		$mytab->set_tab("d","",$page_tal);
		
		?>';
		$this->saveFile($this->path.$this->car_modules."/".$module_code."/".$this->car_processor."/proc_".$table_name.".php",$txt_processor);
	}
	
	function GenerateSrc($mod_mane,$table_name)
	{
		$is_genera_to_lang = $this->_a_modules_type[$mod_mane];

		$module_code = $this->getModuleCode($mod_mane);
		/*obteniendo info  de la tabla*/
		$info_table = $this->_DB_new->db_dscTable($table_name);
		//var_dump($info_table);		exit;
		$primari_key = "";
		
		$add_text_fun = "";
		foreach($info_table as $val_column_name => $val_column_value)
		{
			$add_dfadsfad = "";
			if($val_column_value['primary'])
			{
				$primari_key = $val_column_value['name'];
				$add_dfadsfad = "//";
			}
			
			if($val_column_value['primary'] == $primari_key)
			{
				$add_dfadsfad = "//";
			}
			
			if($is_genera_to_lang == "1")
			{
				$add_text_fun .= '
					       '.$add_dfadsfad.'$this->'.$val_column_value['name'].' = $apost[\'txt_'.$val_column_value['name'].'_\'.$row_langs[\'l_id\']];';
			}else
			{
				$add_text_fun .= '
				'.$add_dfadsfad.'$this->'.$val_column_value['name'].' = $apost[\'txt_'.$val_column_value['name'].'\'];';
			}
			
			
			
		}
		
		if($is_genera_to_lang == "1")
		{
			$add_text_fun_complete = '
				switch($apost["action"])
				{
					case "new";
						/*Registrando ra_content*/
						$this->ra_content->newRow();
						$this->ra_content->m_id = MODULE_ID;
						if($this->ra_content->doInsert())
						{
							$id_cont = $this->ra_content->max();
							/*Registrando ra_content_lang y ra_catalogo*/
							$rs_langs = getLangs();					
							while($row_langs = $this->nextrow($rs_langs))
							{
								$this->ra_content_lang->newRow();
								$this->ra_content_lang->l_id = $row_langs[\'l_id\'];
								$this->ra_content_lang->cl_c_id = $id_cont;
								$this->ra_content_lang->cl_name = $apost[\'txt_cl_name_\'.$row_langs[\'l_id\']];
								$this->ra_content_lang->cl_name_id = $this->ra_content_lang->getnameid($apost[\'txt_cl_name_id_\'.$row_langs[\'l_id\']],$apost[\'txt_cl_name_\'.$row_langs[\'l_id\']],$id_cont);
								$this->ra_content_lang->cl_description = $apost[\'txt_cl_description_\'.$row_langs[\'l_id\']];
								//$this->ra_content_lang->cl_status = $apost[\'txt_cl_status_\'.$row_langs[\'l_id\']];
								$this->ra_content_lang->doInsert();
								
								$idracola = $this->ra_content_lang->max();
								
								/*autogenerar ra_catalogo*/
								
								$this->newRow();
								$this->'.$primari_key.' = $idracola;
								'.$add_text_fun.'
								$this->doInsert();
								
							}							
							return true;
						}else
						{
							return false;
						}
						
						break;
					case "edit";
						$this->ra_content->getRow($ID);
						$rs_langs = getLangs();					
						while($row_langs = $this->nextrow($rs_langs))
						{
							$this->getRowByLang($ID,$row_langs[\'l_id\']);
							//$this->ra_content_lang->l_id = $row_langs[\'l_id\'];
							//$this->ra_content_lang->cl_c_id = $ID;
							$this->ra_content_lang->cl_name = $apost[\'txt_cl_name_\'.$row_langs[\'l_id\']];
							$this->ra_content_lang->cl_name_id = $this->ra_content_lang->getnameid($apost[\'txt_cl_name_id_\'.$row_langs[\'l_id\']],$apost[\'txt_cl_name_\'.$row_langs[\'l_id\']],$ID);
							$this->ra_content_lang->cl_description = $apost[\'txt_cl_description_\'.$row_langs[\'l_id\']];
							//$this->ra_content_lang->cl_status = $apost[\'txt_cl_status_\'.$row_langs[\'l_id\']];
							$this->ra_content_lang->doUpdate();
							/*autogenerar ra_catalogo*/
							'.$add_text_fun.'
							$this->doUpdate();
						}						
						return true;
						break;
					default:
						return false;
				}
			';
		}else
		{
			$add_text_fun_complete = $add_text_fun;
		}
		
		$txt_src = '<?php
			class '.$table_name.' extends Table_Orm
			{
				var $_table = "'.$table_name.'";
				var $_primary_key = "'.$primari_key.'";
				';
			
				if($is_genera_to_lang == "1")
				{
				$txt_src .=	'
					var $ra_content;
					var $ra_content_lang;
				';	
				}
			
				$txt_src .=		'
				function __construct($inDB)
				{
					$this->_DB = $inDB;
					$this->newRow();
					';
					if($is_genera_to_lang == "1")
					{
					$txt_src .=	'
					$this->ra_content = newClassMod("ra_content","mod_admin");
					$this->ra_content_lang = newClassMod("ra_content_lang","mod_admin");
					';	
					}
				$txt_src .=		'
				}
				
				function GetValsForm($apost,$ID="")
				{
					'.$add_text_fun_complete.'
				}
				
				';
				if($is_genera_to_lang == "1")
				{
					$txt_src .=		'
					
					';
				}
				$txt_src .=		'
				
			}
		?>';
		
		$this->saveFile($this->path.$this->car_modules."/".$module_code."/".$this->car_src."/class_".$table_name.".php",$txt_src);
	}

	function GenerateFilesIniModule($mod_mane,$mod_tables)
	{
		/*creating conf.php*/
		$module_code = $this->getModuleCode($mod_mane);
		$txt_file = '
		<?php
		//NokTemplate
		$tpl = &new tpl_nok_template();					
		$tpl->set_dir_template(PATH_MODULE."templates/");
		$tpl->open();
		
		define("MODULE_ID",$ob_modulo_name->m_id);	
		$tpl->assign("MODULE_ID", MODULE_ID);	
		
		/*basic url*/		
		
		$basic_url_get = SERVER_ADMIN."?module=".$_SESSION[\'module\']."&mod=".$_GET[\'mod\'];
		
		if(isset($_GET[\''.$table_name.'\']))
		{
			$GLOBALS[\'urlback\'] = SERVER_ADMIN."?module=".$_GET[\'module\']."&mod=".$_GET[\'mod\'];
		}
		
		$tpl->assign("basic_url_get", $basic_url_get);
		
		$tpl->assign("SERVER_NAME", SERVER_NAME);
		$tpl->assign("SERVER_PATH", SERVER_PATH);
		
		$tpl->assign("PATH_ADMIN", PATH_ADMIN);
		$tpl->assign("SERVER_ADMIN", SERVER_ADMIN);
		
		$tpl->assign("MODULE", $_SESSION[\'module\']);
		$tpl->assign("mod", $_GET[\'mod\']);
		
		if(@$_SESSION[\'SES_TYPEMSG\'] != "" && @$_SESSION[\'SES_MSGBOX\'] != "")
		{
			$GLOBALS[\'TYPEMSG\'] = $_SESSION[\'SES_TYPEMSG\'];
			$GLOBALS[\'MSGBOX\'] = $_SESSION[\'SES_MSGBOX\'];
			unset($_SESSION[\'SES_TYPEMSG\'],$_SESSION[\'SES_MSGBOX\']);
		}
		?>
		';
		$this->saveFile($this->path.$this->car_modules."/".$module_code."/conf.php",$txt_file);
		
		/*creating mnu.inc.php*/
		
		/*
		$txt_file = '<?php
			$men = new menu($DB);
			$men->mod_default = "";
			$men->viewMyMenu("'.$module_code.'");				
			$men->show($ob_modulo_name->m_name);
		?>

		';
		$this->saveFile($this->path.$this->car_modules."/".$module_code."/mnu.inc.php",$txt_file);
		*/
		
		$this->connectToNewDB();
		/*insertando modulo en db*/
		$ob_modulos = newClassMod("ra_module","mod_modules");
		$ob_modulos->_DB = $this->_DB_new;
		
		$ob_modulos->getRowByCols(array("m_code"=>$module_code));
		$id_module = $ob_modulos->m_id;
		if($id_module == "")
		{
			$ob_modulos->m_name  = $mod_mane;
			$ob_modulos->m_code  = $module_code;
			$ob_modulos->m_type = 0;
			$ob_modulos->m_icon = "";
			$ob_modulos->m_status = 1;
			
			
			$ob_modulos->doInsert();
			
			$ob_modulos->getRowByCols(array("m_code"=>$module_code));
			$id_module = $ob_modulos->m_id;
		}
		//echo $module_code."=>".$id_module."<br>";
		
		/*creating tabs.php*/
		
		$txt_code_tabs = "<div class=\"modulo\">
<?php		
		\$mytab = new tabs();
		switch(\$_M)
		{	
		";
		
		$ob_paginas = newClassMod("ra_page","mod_modules"); 
		$ob_paginas->_DB = $this->_DB_new;
		
		
		
		foreach($mod_tables as $table_namedd)
		{
			/*agregando las tablas al modulo*/
			$ob_paginas->getRowByCols(array("p_name"=>$table_namedd,"m_id"=>$id_module));
			if($ob_paginas->p_id == "")
			{
				$ob_paginas->m_id = $id_module;
				$ob_paginas->p_name	 = $table_namedd;
				$ob_paginas->p_icon = "";
				$ob_paginas->p_status = 1;
				$ob_paginas->doInsert();
				$ob_paginas->getRowByCols(array("p_name"=>$table_namedd,"m_id"=>$id_module));
			}
			
			/*asignando permisos*/
			/*$ob_ra_administrator_page = newClassMod("ra_administrator_page",$this->_mod_admin_name); 
			$ob_ra_administrator_page->_DB = $this->_DB_new;
			$ob_ra_administrator_page->newRow();
			
			$ob_ra_administrator_page->a_id = 1;
			$ob_ra_administrator_page->p_id = $ob_paginas->p_id;
			$ob_ra_administrator_page->ap_shortcut = 0;
			$ob_ra_administrator_page->doInsert();*/
			
			$txt_code_tabs .= "
			case ".$ob_paginas->p_id.":
				include_once(PATH_MODULE.\"processor/proc_".$table_namedd.".php\");
				break;
			";
		}
		
		$txt_code_tabs .= "
			default:
					header(\"Location: \".SERVER_ADMIN.\"?gohome=1\");
		}
		\$mytab->show(\$tpl);
		?>
</div>

		";
		$this->saveFile($this->path.$this->car_modules."/".$module_code."/tabs.php",$txt_code_tabs);
		return $id_module;
	}
	
	 function smartCopy($source, $dest, $folderPermission=0777,$filePermission=0777)
	 {
	 	//echo $source;
		# source=file & dest=dir => copy file from source-dir to dest-dir
		# source=file & dest=file / not there yet => copy file from source-dir to dest and overwrite a file there, if present
		
		# source=dir & dest=dir => copy all content from source to dir
		# source=dir & dest not there yet => copy all content from source to a, yet to be created, dest-dir
		$result=false;
	   
		if (is_file($source)) { # $source is file
			if(is_dir($dest)) { # $dest is folder
				if ($dest[strlen($dest)-1]!='/') # add '/' if necessary
					$__dest=$dest."/";
				$__dest .= basename($source);
				}
			else { # $dest is (new) filename
				$__dest=$dest;
				}
			$result=copy($source, $__dest);
			chmod($__dest,$filePermission);
			}
		elseif(is_dir($source)) { # $source is dir
			if(!is_dir($dest)) { # dest-dir not there yet, create it
				@mkdir($dest,$folderPermission);
				chmod($dest,$folderPermission);
				}
			if ($source[strlen($source)-1]!='/') # add '/' if necessary
				$source=$source."/";
			if ($dest[strlen($dest)-1]!='/') # add '/' if necessary
				$dest=$dest."/";
	
			# find all elements in $source
			$return = true; # in case this dir is empty it would otherwise return false
			$dirHandle=opendir($source);
			while($file=readdir($dirHandle)) { # note that $file can also be a folder
				if($file!="." && $file!="..") { # filter starting elements and pass the rest to this function again
	#                echo "$source$file ||| $dest$file<br />\n";
					$result=$this->smartCopy($source.$file, $dest.$file, $folderPermission, $filePermission);
					}
				}
			closedir($dirHandle);
			}
		else {
			$result=false;
			}
		return $result;
    } 
	

}

?>
