<?php

require_once("class.NokTemplate.php");

class table_template {

var $tpl;
var $arch_template;
var $datos;
var $tTabla = "tTabla";
var $tFila = "tFila";
var $FILAS = "FILAS";
var $functione = "get_param_fil";

function table_template()
{
	$this->tpl = null;
	$this->arch_template = null;
	$this->datos = null;
}

function get_tpl() {
	return $this->tpl;
}

function set_tpl(&$tpl) {
	$ok = false;
	
	if(is_object($tpl)) { 
		$this->tpl = &$tpl; 
		$ok = true;
	} 
	
	return $ok;
}

function get_arch_template() {
	return $this->arch_template;
}

function set_arch_template($arch_template) {
	$ok = false;

	if(is_file($this->dir_template.$arch_template)) { 
		$this->arch_template = $arch_template;			
		$ok = true;
	}
	
	return $ok;
}

function get_datos() {
	return $this->datos;
}

function set_datos($datos) {
	$ok = false;
	
	if(is_array($datos)) { 
		$this->datos = $datos;  
		$ok = true;
	} 
	
	return $ok;
}

function load_result($result, &$DB) {
	$this->datos = null;
	$i = 0;
	while($row = $DB->db_fetchrow($result)) {
		//var_dump($row); exit;
		$assign = false;
		foreach($row as $key => $value)
		{
			if( !is_numeric($key) ) { 
			//if(true){
				$this->datos[$i][$key] = $value;
			}
			
			if($assign) {
				$assign = false;
			} else {
				$assign = true;			
			}
		}
		//var_dump($this->datos[$i]); exit;
		$i++;
	}
}

function open($name_template = null) { 
	if(is_null($name_template)) {
		$name_template = "template";
	}

	if(!is_null($this->arch_template)) { 
		$this->tpl->load($name_template, $this->arch_template);
		$this->tpl->set_block($this->tTabla, $name_template); 
	}

	$this->tpl->set_block($this->tFila, $name_template); 
}

function assign($name, $value) {
	$this->tpl->assign($name, $value);
}

function load_fil() {
    $this->tpl->assign($this->FILAS, "");

	for($i = 0; $i < count($this->datos); $i++)
	{
		$fil = $this->datos[$i];
		//var_dump($fil); exit;
		foreach($fil as $key => $value) {
			$this->tpl->assign($key, $fil[$key]);
		}
		
		if(function_exists($this->functione))
		{
			eval("\$param = $this->functione (\$i + 1, \$fil);");
			//$param = get_param_fil(); 
			//var_dump($param);
			foreach($param as $key => $value)
			{
				$this->tpl->assign($key, $value);
			}
		}

	    $this->tpl->assign($this->FILAS, $this->tFila, 1, "+");
	}
}

function show() {
	$this->tpl->show($this->tTabla);
}

} //Fin clase table_template 


?>