$(document).on('ready', function () {
    // Custom Selects
    if ($('[data-toggle="select"]').length) {
        $('[data-toggle="select"]').select2();
    }

    // Checkboxes and Radio buttons
    $('[data-toggle="checkbox"]').radiocheck();
    $('[data-toggle="radio"]').radiocheck();

    //- Validate
    var validateForm = $('#frmPollP1').validate({
        highlight: function (element) {
            var elem = $(element);
            if (elem.hasClass("select2-offscreen")) {
                $("#s2id_" + elem.attr("id") + " ul").closest('.form-group').addClass('has-error').removeClass('has-success');
            } else {
                $(element).closest('.form-group').addClass('has-error').removeClass('has-success');
            }
        },
        unhighlight: function (element) {
            var elem = $(element);
            if (elem.hasClass("select2-offscreen")) {
                $("#s2id_" + elem.attr("id") + " ul").closest('.form-group').removeClass('has-error').addClass('has-success');
            } else {
                $(element).closest('.form-group').removeClass('has-error').addClass('has-success');
            }
        }
    });


    $(document).on("change", ".select2-offscreen", function () {
        if (!$.isEmptyObject(validateForm.submitted)) {
            validateForm.form();
        }
    });
});


function checkOption(isFilter, qtId, qValue, orderi) {
    if (isFilter) {
        if (qValue == 0 && qtId != 1) {
            $("#txt_pasofiltro").val("0");
            document.frmPollP1.submit();
        }
    } else {
        checkOptionQuestion(orderi);
    }
}

function checkOptionQuestion(orderi) {
    ObImput = $('.questionval' + orderi);
    switch (ObImput.attr('type')) {
        case "radio":
        case "checkbox":
            valI = $('.questionval' + orderi + ':checked').val();
            break;
        default:
            valI = ObImput.val();
    }
    if (valI != '' && valI != undefined) {
        activeBtnNext();
    } else {
        disableBtnNext();
    }
}

var totalQuestions = 0;
var actualQuestion = 0;
function loadchecFrmQuestion(totalQ) {
    disableBtnBack();
    disableBtnNext();
    totalQuestions = totalQ;
}

function btnpollBack() {
    $("#tab" + actualQuestion).hide();
    actualQuestion--;
    $("#tab" + actualQuestion).show();
    if (actualQuestion > 0) {
        activeBtnBack();
    } else {
        disableBtnBack();
    }
    activeBtnNext();
    $("#btnpoll1Next").html('<span>Siguiente</span><span class="fui-arrow-right"></span>')
}

function btnpollNext() {
    if (checkResp()) {
        $("#tab" + actualQuestion).hide();
        actualQuestion++;
        if (actualQuestion >= totalQuestions) {
            $(".navOptions").hide();
            document.frmPollP2.submit();
        } else {
            $("#tab" + actualQuestion).show();
            activeBtnBack();
            if (actualQuestion < (totalQuestions - 1)) {
                $("#btnpoll1Next").html('<span>Siguiente</span><span class="fui-arrow-right"></span>')
            } else {
                disableBtnNext();
                $("#btnpoll1Next").html('<span class="fui-check"></span> <span>Finalizar</span>')
            }
            checkOptionQuestion(actualQuestion);
        }
    }

}

function checkResp() {
    var obTab = $("#tab" + actualQuestion);
    var idTypeQa = obTab.attr("typeQuestionId");
    var returnOper = true;
    if (idTypeQa == "9" || idTypeQa == "10") {
        if ($("#frmPollP2").valid()) {
            var aDatos = [];
            var sumatoria = 0;

            $(".questionval" + actualQuestion).each(function () {
                if (idTypeQa == "9") {//Ordinal
                    if (returnOper) {
                        valordd = $(this).val();
                        if ($.inArray(valordd, aDatos, 0) == -1) {
                            aDatos.push(valordd);
                        } else {
                            alert("El órden es incorrecto.");
                            returnOper = false;
                        }
                    }
                } else {
                    sumatoria += parseInt($(this).val());
                }
            });
            if (idTypeQa == "10") {//Fraccionar
                totalSumatorio = parseInt(obTab.attr("sumTotalQuestion"));
                if (totalSumatorio != sumatoria) {
                    returnOper = false;
                    alert("La sumatoria debe ser " + totalSumatorio);
                }
            }
        } else {
            returnOper = false;
        }
    }

    return returnOper;
}

function disableBtnNext() {
    $("#btnpoll1Next").attr("disabled", true);
}

function disableBtnBack() {
    $("#btnpoll1Back").attr("disabled", true);
}

function activeBtnNext() {
    $("#btnpoll1Next").attr("disabled", false);
}

function activeBtnBack() {
    $("#btnpoll1Back").attr("disabled", false);
}


