<?php
$ob_p_poll = $GLOBALS["ob_p_poll"];
$aFilters = $ob_p_poll->downloadImporModelGetQuestion($ob_p_poll->p_id, "F", true);
$ob_p_poll->combineaDataPoll($aFilters);
$aSegments = $ob_p_poll->downloadImporModelGetQuestion($ob_p_poll->p_id, "S", true);
$ob_p_poll->combineaDataPoll($aSegments);
$aQuestions = $ob_p_poll->downloadImporModelGetQuestion($ob_p_poll->p_id, "Q", true);
$ob_p_poll->combineaDataPoll($aQuestions);
require_once PATH_ADMIN . '/library/PHPExcel_1.8.0_doc/Classes/PHPExcel.php';
$objReader = PHPExcel_IOFactory::createReader('Excel2007');
$objReader->setReadDataOnly(true);

$objPHPExcel = $objReader->load($GLOBALS['fichero_subido']);
$objWorksheet = $objPHPExcel->setActiveSheetIndex(1);

$highestRow = $objWorksheet->getHighestRow();
$highestColumn = $objWorksheet->getHighestColumn();
$highestColumnIndex = PHPExcel_Cell::columnIndexFromString($highestColumn);

$aDataCols = array();
$aDataCols[] = "";

$aDataValues = array();
$aDataValues[] = "";
//var_dump($ob_p_poll->aDataPoll); exit;
foreach ($ob_p_poll->aDataPoll as $questionData) {
    foreach ($questionData["columns"] as $questiocolum) {
        $aDataCols[] = $questiocolum['code'];
    }
    $aDataValues[$questionData['id']] = $questionData["values"];
}
$is_errors = false;
?>
<script>
    function import_data_conf(is_errors) {
        if (is_errors) {
            var txt = "El archivo tiene información que no es correcta, confirma si desea importar.";
            $("#dialog:ui-dialog").dialog("destroy");
            $("#inDiv_html_delete").html(txt);
            $("#dialog-confirm-delete").dialog({
                resizable: false,
                modal: true,
                title: "Confirmación",
                buttons: {
                    "Importar": function () {
                        import_data();
                    },
                    "Cancelar": function () {
                        $(this).dialog("close");
                    }
                },
            });
        } else {
            import_data();
        }
    }

    function import_data() {
        alertUIAction("Procesando...");
        setTimeout(function () {
            document.location = "?module=mod_poll&mod=<?= $_GET['mod'] ?>&p_poll=modelimportconfirm&idPoll=<?= $_GET['idPoll'] ?>";
        }, 1500);
    }
</script>
<div class="mod-content">
    <div id="tabs">
        <ul>
            <li><a href="#tabs-1"><?= $ob_p_poll->p_title ?> > Importar Datos</a></li>
        </ul>
        <div id="tabs-1" style="overflow-x: scroll">
            <form name = "frm_p_poll_question" id="frmadmin" action = "" METHOD="POST" >
                <input type="hidden" name="fileimported" value="<?= $GLOBALS['fichero_subido'] ?>" />
                <table style="width: 100%" >
                    <?php
                    /* validando columnas */
                    echo '<table border="1">' . "\n";
                    echo '<tr><td></td>' . "\n";
                    //for ($col = 0; $col < $highestColumnIndex; ++$col) {
                    foreach ($ob_p_poll->aDataPoll as $questionData) {
                        $htmlAnswers = "";
                        foreach ($questionData['answers'] as $preg_anser) {
                            $htmlAnswers .= $preg_anser;
                        }
                        echo '<td valing=top colspan="' . count($questionData["columns"]) . '"><b>' . $questionData['question'] . "</b>" . $htmlAnswers . '</td>';
                    }

                    echo '</tr>' . "\n";
                    echo '<tr>' . "\n";
                    foreach ($aDataCols as $col => $colnamed) {

                        if ($col > 0) {
                            $color = "green";
                            $value_excel = $objWorksheet->getCellByColumnAndRow($col, 2)->getValue();
                            if ($colnamed != $value_excel) {
                                $color = "red";
                                $is_errors = true;
                            }
                            echo '<th style="color:' . $color . '"><b>' . $value_excel . '</b></th>' . "\n";
                        } else {
                            echo '<th>Numero</th>' . "\n";
                        }
                    }
                    echo '</tr>' . "\n";

                    for ($row = 3; $row <= $highestRow; ++$row) {
                        echo '<tr>' . "\n";
                        for ($col = 0; $col < $highestColumnIndex; ++$col) {
                            $valor_imgresado = $objWorksheet->getCellByColumnAndRow($col, $row)->getValue();
                            $color = "green";
                            if ($col > 0) {

                                $aTitleDatos = explode(".", $aDataCols[$col]);
                                if ($aTitleDatos[2] == "0" && $aDataCols[$col] != "S.2.0") {
                                    if (!in_array($valor_imgresado, $aDataValues[$aTitleDatos[1]])) {
                                        $color = "red";
                                        $is_errors = true;
                                    }
                                }
                            }
                            echo '<td style="color:' . $color . '">' . $valor_imgresado . '</td>' . "\n";
                        }

                        echo '</tr>' . "\n";
                    }
                    echo '</table>' . "\n";
                    ?>
                </table>
                <br>
                <p>
                    <button title="Enviar" name="btn_register_p_poll_question" onclick="import_data_conf(<?= $is_errors ?>)" id="btn_register_p_poll_question" type="button">Importar</button>
                </p>

            </form>
        </div>
    </div>
</div>

