<?php

class Table_Orm {

    /**
     * Map de la tabla
     * @var array
     */
    public $_row;
    public $_DB;
    public $_columnas;

    function __construct() {
        
    }

    /**
     * M�todo para obtener el nombre de la tabla
     * @return string  
     * @access public
     * */
    public function getTable() {
        return $this->_table;
    }

    function nameId() {
        return $this->ra_content_lang->cl_name_id;
    }

    function name() {
        return $this->ra_content_lang->cl_name;
    }

    function getVar($namve) {
        return $this->ra_content_lang->$namve;
    }

    function setOrder($cl_c_id, $new_order = 0, $where_add = "") {
        $where_add_and = "";
        if ($where_add != "") {
            $where_add_and = " and " . $where_add;
        }

        if ($new_order == 0) {
            if (isset($this->ra_content)) {

                $new_order = $this->maxLang("", "", "cl_order", $where_add_and);
                $new_order += 1;
                //echo $new_order; exit;
            } else {
                $new_order = $this->max($where_add, "cl_order") + 1;
            }
        }

        switch ($new_order) {
            case "+":
                $new_order = "cl_order+1";
                break;
            case "-":
                $new_order = "cl_order-1";
                break;
        }



        if (isset($this->ra_content)) {
            //$sql_upd = "update ra_content_lang set cl_order = ".$new_order." where cl_c_id = '".$cl_c_id."' ".$where_add_and;
            $sql_upd = "update ra_content_lang set cl_order = " . $new_order . " where cl_c_id = '" . $cl_c_id . "' ";
        } else {
            //$sql_upd = "update ".$this->_table." set cl_order = ".$new_order." where ".$this->_primary_key." = '".$cl_c_id."' ".$where_add_and;
            $sql_upd = "update " . $this->_table . " set cl_order = " . $new_order . " where " . $this->_primary_key . " = '" . $cl_c_id . "' ";
        }


        $this->_DB->db_query($sql_upd);
    }

    function getIDFromOrder($order = 0, $where_add = "") {
        $where_add_and = "";
        if ($where_add != "") {
            $where_add_and = " and " . $where_add;
        }

        if (isset($this->ra_content)) {
            $sql_ord = $this->getSQL("", "", ",cl_order") . " and cl_order = " . $order . " " . $where_add_and;
            $rs_ord = $this->_DB->db_query($sql_ord);
        } else {
            $rs_ord = $this->getAll("cl_order = '" . $order . "' " . $where_add_and);
        }


        if ($row_ord = $this->nextrow($rs_ord)) {
            if (isset($this->ra_content)) {
                return $row_ord['cl_c_id'];
            } else {
                return $row_ord[$this->_primary_key];
            }
        } else {
            return 0;
        }
    }

    function updateorder($where_add = "") {
        $this->opdateorder($where_add);
    }

    function opdateorder($where_add = "") {
        if (isset($this->ra_content)) {
            $other_addsql = "";
            if ($where_add != "") {
                $other_addsql = " and " . $where_add;
            }
            $sql_ord = $this->getSQL("", "", ",cl_order") . " " . $other_addsql . " order by cl_order";
            $rs_ord = $GLOBALS['DB']->db_query($sql_ord);
        } else {
            $rs_ord = $this->getAll($where_add, " cl_order ");
        }


        $contadordfdfdd = 1;
        while ($row_ord = $this->nextrow($rs_ord)) {
            if (isset($this->ra_content)) {
                $this->setOrder($row_ord['cl_c_id'], $contadordfdfdd, $where_add);
            } else {
                $this->setOrder($row_ord[$this->_primary_key], $contadordfdfdd, $where_add);
            }
            $contadordfdfdd++;
        }
    }

    public function getAllCount($eWhere = "", $orderby = "", $limit = "", $cache = false) {
        $where = "";

        if ($eWhere != "") {
            if (is_array($eWhere)) {
                $where = $this->getWhere($eWhere);
            } else if (is_string($eWhere)) {
                $where = $eWhere;
            }
        }

        $add_where = "";

        if ($where != "") {
            $add_where = " where $where ";
        }

        $add_orderby = "";

        if ($orderby != "") {
            $add_orderby = " order by " . $orderby . " ";
        }

        $add_limit = "";

        if ($limit != "") {
            $add_limit = " limit " . $limit . " ";
        }

        $sql = "
		select count(" . $this->_primary_key . ") as numrow
		from $this->_table		
		" . $add_where . $add_orderby . $add_limit;
        //echo $sql; exit;
        $rs = $this->_DB->db_query($sql, $cache);

        if ($row = $this->nextRow($rs)) {
            $numret = $row['numrow'];
        } else {
            $numret = 0;
        }
        return $numret;
    }

    /* ----------------------Metodos SET Y GET ------------------------------- */

    /**
     * Get de los valores de todas las columnas.
     * @param string $val columna
     * @return string
     * @throws Zend_Db_Table_Row
     * @access public
     */
    public function __get($val) {
        //echo $val."<br>";	
        $val = trim($val);

        $r = (stripslashes(@$this->_row->$val));



        return $r;
    }

    function quitarAcentos($text) {


        $text = htmlentities($text, ENT_QUOTES, 'UTF-8');
        $text = strtolower($text);
        $patron = array(
            // Espacios, puntos y comas por guion
            '/[\., ]+/' => '-',
            // Vocales
            '/&agrave;/' => 'a',
            '/&egrave;/' => 'e',
            '/&igrave;/' => 'i',
            '/&ograve;/' => 'o',
            '/&ugrave;/' => 'u',
            '/&aacute;/' => 'a',
            '/&eacute;/' => 'e',
            '/&iacute;/' => 'i',
            '/&oacute;/' => 'o',
            '/&uacute;/' => 'u',
            '/&acirc;/' => 'a',
            '/&ecirc;/' => 'e',
            '/&icirc;/' => 'i',
            '/&ocirc;/' => 'o',
            '/&ucirc;/' => 'u',
            '/&atilde;/' => 'a',
            '/&etilde;/' => 'e',
            '/&itilde;/' => 'i',
            '/&otilde;/' => 'o',
            '/&utilde;/' => 'u',
            '/&auml;/' => 'a',
            '/&euml;/' => 'e',
            '/&iuml;/' => 'i',
            '/&ouml;/' => 'o',
            '/&uuml;/' => 'u',
            '/&auml;/' => 'a',
            '/&euml;/' => 'e',
            '/&iuml;/' => 'i',
            '/&ouml;/' => 'o',
            '/&uuml;/' => 'u',
            // Otras letras y caracteres especiales
            '/&aring;/' => 'a',
            '/&ntilde;/' => 'n',
            '/&#92;/' => '',
            '/&#64;/' => '',
            '/&#63;/' => '',
            '/&#34;/' => '',
            '/&#38;/' => '',
                // Agregar aqui mas caracteres si es necesario
        );

        $text = preg_replace(array_keys($patron), array_values($patron), $text);


        //var_dump($text); exit;

        $text = str_replace("(", "", $text);
        $text = str_replace(")", "", $text);
        $text = str_replace(".", "", $text);
        $text = str_replace("?", "", $text);
        $text = str_replace('"', "", $text);
        $text = str_replace("!", "", $text);
        $text = str_replace("¡", "", $text);
        $text = str_replace(" ", "", $text);
        $text = str_replace("'", "", $text);
        $text = str_replace("&", "and", $text);

        //var_dump($text); exit;
        return $text;
    }

    function getnameid($posttxtid, $posttxt_name, $id) {

        //echo $posttxtid."<br>";

        if ($posttxtid == "") {
            $posttxtid = $posttxt_name;
        }
        $posttxtid = mb_strtolower($posttxtid, 'UTF-8');
        //echo $posttxtid."<br>";



        $name_ret = str_replace(" ", "-", $this->quitarAcentos($posttxtid));

        /* verificando si existe esta id en la db */

        $sql = "
		select * from ra_content_lang where cl_name_id = '" . $name_ret . "' and cl_c_id != '" . $id . "'
		";

        $rs = $this->_DB->db_query($sql);

        if ($row = $this->nextrow($rs)) {
            $name_ret = $id . "-" . $name_ret;
        }

        $name_ret = str_replace("/", "-", $name_ret);
        $name_ret = str_replace("%", "", $name_ret);
        $name_ret = str_replace("\"", "", $name_ret);

        return $name_ret;
    }

    /**
     * Set de los valores de todas las columnas. 
     * @param string $n columna
     * @param string $val valor de la columna
     * @access public
     * @throws Zend_Db_Table_Row
     * @return void
     */
    public function __set($n, $val) {
        //echo $n."->".$val."<br>";
        $val = str_replace("'", "&apos;", $val);
        $this->_row->$n = addslashes($val);
    }

    /** Metodo para crear un registro vacio
     * @access public
     * */
    public function newRow() {
        $cols = $this->_DB->db_dscTable($this->_table);
        //$this->_row = "";
        $this->_row = new stdClass();
        if (is_array($cols)) {
            foreach ($cols as $col_values) {
                $this->_row->$col_values['name'] = "";
            }
        }
        $this->_columnas = $cols;
    }

    public function getRow($id, $is_return = false, $cache = false) {
        //echo "get row";
        if (!$is_return) {
            $this->newRow();
        }


        $sql = "
		select * 
		from $this->_table
		where  $this->_primary_key = '" . $id . "'
		";
        //echo $sql;
        //var_dump($this->_columnas); exit;
        $rs = $this->_DB->db_query($sql, $cache);
        if ($row = $this->_DB->db_fetchrow($rs)) {
            if ($is_return == false) {
                foreach ($this->_columnas as $col_name => $col_values) {
                    //echo $col_name."<--<br>";
                    $this->_row->$col_name = $row[$col_name];
                }
            } else {

                return $row;
            }
        }
    }

    /*
     * @a_cols = array("colname"=>"value")
     */

    function getRowByCols($a_cols, $cache = false, $is_return = false) {
        if (!$is_return) {
            $this->newRow();
        }


        $str_where = "";

        if (is_array($a_cols)) {
            $tem_array = array();
            foreach ($a_cols as $a_ids => $a_values) {
                $tem_array[] = $a_ids . "='" . $a_values . "'";
            }
            $str_where = implode(" and ", $tem_array);
        } else {
            $str_where = $a_cols;
        }

        $sql = "
		select * 
		from $this->_table
		where  " . $str_where . "
		";
        ///echo $sql."<br>-<br>";
        $rs = $this->_DB->db_query($sql, $cache);
        if ($row = $this->_DB->db_fetchrow($rs)) {
            if ($is_return == false) {
                if (is_array($this->_columnas)) {
                    foreach ($this->_columnas as $col_name => $col_values) {
                        if (empty($row[$col_name]) || $row[$col_name] == "") {
                            $this->_row->$col_name;
                        } else {
                            $this->_row->$col_name = $row[$col_name];
                        }
                    }
                }
            } else {
                return $row;
            }
        }
    }

    public function __call($method, $args) {

        echo "$method =>  este método no está definido y/o implementado<br>";
    }

    function getRowByLang($ID, $lang, $cache = false, $fromid = true) {
        if (!$fromid) {
            /* buscando por id texto name_id */

            $this->ra_content_lang->getRowByCols(array("cl_name_id" => $ID, "l_id" => $lang), $cache);
            $this->ra_content->getRow($this->ra_content_lang->cl_c_id, false, $cache);
        } else {
            $this->ra_content->getRow($ID, false, $cache);
            $this->ra_content_lang->getRowByCols(array("cl_c_id" => $ID, "l_id" => $lang), $cache);
        }

        //echo $this->ra_content_lang->cl_id."<br>";

        $this->getRow($this->ra_content_lang->cl_id, false, $cache);
    }

    function maxLang($lang = "", $module = "", $name_col_max = "", $where_add = "") {
        if ($lang == "") {
            $lang = LANG;
        }

        if ($module == "") {
            $module = MODULE_ID;
        }

        if ($name_col_max == "") {
            $name_col_max = "cl_c_id";
        }

        $sql = "
		select 
			max(" . $name_col_max . ") as namemax
		from " . $this->ra_content->_table . ", " . $this->ra_content_lang->_table . " , " . $this->_table . "
		where 
			" . $this->ra_content->_table . "." . $this->ra_content->_primary_key . " = " . $this->ra_content_lang->_table . ".cl_c_id and
			" . $this->ra_content_lang->_table . ".l_id = '" . $lang . "' and
			" . $this->ra_content_lang->_table . "." . $this->ra_content_lang->_primary_key . " = " . $this->_table . "." . $this->_primary_key . " and
			" . $this->ra_content->_table . ".m_id = '" . $module . "' and
			" . $this->ra_content_lang->_table . ".cl_status < 2
			" . $where_add . "
		";

        //echo $sql; exit;
        $rs = $this->_DB->db_query($sql);
        $row = $this->nextrow($rs);
        return $row['namemax'];
        //return $sql;
    }

    function getSQL($lang = "", $module = "", $add_name_col = "", $where_add = "", $select_c_add = "") {
        if ($lang == "") {
            $lang = LANG;
        }

        if ($module == "") {
            $module = MODULE_ID;
        }

        $sql = "
		select 
			" . $this->ra_content->_table . "." . $this->ra_content->_primary_key . " as " . $this->ra_content->_primary_key . $add_name_col . ", 
			" . $this->ra_content_lang->_table . ".l_id as l_id" . $add_name_col . ", 
			" . $this->ra_content_lang->_table . ".cl_c_id  as cl_c_id" . $add_name_col . ", 
			" . $this->ra_content_lang->_table . ".cl_name  as cl_name" . $add_name_col . ", 
			" . $this->ra_content_lang->_table . ".cl_name_2  as cl_name_2" . $add_name_col . ", 			
			" . $this->ra_content_lang->_table . ".cl_name_id  as cl_name_id" . $add_name_col . ", 
			" . $this->ra_content_lang->_table . ".cl_description  as cl_description" . $add_name_col . ", 
			" . $this->ra_content_lang->_table . ".cl_status  as cl_status" . $add_name_col . ", 
			" . $this->ra_content_lang->_table . ".cl_img_pincipal  as cl_img_pincipal" . $add_name_col . ", 
			" . $this->ra_content_lang->_table . ".cl_order  as cl_order" . $add_name_col . ", 			
			
			
			" . $this->_table . ".* " . $select_c_add . "
		from " . $this->ra_content->_table . ", " . $this->ra_content_lang->_table . " , " . $this->_table . "
		where 
			" . $this->ra_content->_table . "." . $this->ra_content->_primary_key . " = " . $this->ra_content_lang->_table . ".cl_c_id and
			" . $this->ra_content_lang->_table . ".l_id = '" . $lang . "' and
			" . $this->ra_content_lang->_table . "." . $this->ra_content_lang->_primary_key . " = " . $this->_table . "." . $this->_primary_key . " and
			" . $this->ra_content->_table . ".m_id = '" . $module . "' and
			" . $this->ra_content_lang->_table . ".cl_status < 2
			" . $where_add . "
		";
        //echo $sql;
        return $sql;
    }

    function getSQLUniq($lang = "", $module = "", $where_add = "") {
        if ($lang == "") {
            $lang = LANG;
        }

        if ($module == "") {
            $module = MODULE_ID;
        }

        $sql = "
		select 
			" . $this->ra_content->_table . "." . $this->ra_content->_primary_key . ", 
			" . $this->ra_content_lang->_table . ".l_id , 
			" . $this->ra_content_lang->_table . ".cl_c_id , 
			" . $this->ra_content_lang->_table . ".cl_name , 
			" . $this->ra_content_lang->_table . ".cl_name_id , 
			" . $this->ra_content_lang->_table . ".cl_description , 
			" . $this->ra_content_lang->_table . ".cl_img_pincipal, 
			" . $this->ra_content_lang->_table . ".cl_status,
			DATE_FORMAT(" . $this->ra_content_lang->_table . ".cl_date_event,'%Y-%m-%d')  as cl_date_event,
			" . $this->ra_content_lang->_table . ".cl_destacado
		from " . $this->ra_content->_table . ", " . $this->ra_content_lang->_table . " 
		where 
			" . $this->ra_content->_table . "." . $this->ra_content->_primary_key . " = " . $this->ra_content_lang->_table . ".cl_c_id and
			" . $this->ra_content_lang->_table . ".l_id = '" . $lang . "' and			
			" . $this->ra_content->_table . ".m_id = '" . $module . "'
			" . $where_add . "
		";
        //echo $sql;
        return $sql;
    }

    /* ----------------------Metodos Insert, Update y delete ------------------------------- */

    /** Metodo para insertar un nuevo registro
     * @access public
     * */
    public function doInsert() {
        $nombre_camp_primary = $this->_primary_key;

        $sql = "
		insert into $this->_table set 
		";
        $a_campos = array();
        foreach ($this->_columnas as $nombre_camp_id => $values_camp) {
            //echo $nombre_camp_id."->".$this->$nombre_camp_id."<br>";
            if ($this->$nombre_camp_id != "") {
                $a_campos[] = $nombre_camp_id . "='" . mysql_real_escape_string($this->$nombre_camp_id) . "'";
            }
        }
        $sql .= implode(",", $a_campos);
        //echo $sql; exit;
        //echo $sql."<br>";
        return $this->_DB->db_query($sql);
        //var_dump($this->_columnas);
        //return false;
    }

    /** Metodo para actualizar un registro
     * @access public
     * */
    public function doUpdate() {
        $sql = "
		update $this->_table set 
		";

        $nombre_compumal = $this->_primary_key;
        $row_last_registro = $this->getRow($this->$nombre_compumal, true);

        //var_dump($this->_columnas); exit;

        $a_campos = array();
        foreach ($this->_columnas as $nombre_camp_id => $values_camp) {
            //echo $nombre_camp_id."->".$this->$nombre_camp_id."<br>";
            if ($row_last_registro[$nombre_camp_id] != $this->$nombre_camp_id) {
                $a_campos[] = $nombre_camp_id . "='" . $this->$nombre_camp_id . "'";
            }
        }
        //echo $sql; exit;
        //var_dump($a_campos); exit;
        if (count($a_campos) <= 0) {
            return true;
        }

        //var_dump($a_campos);
        $sql .= implode(",", $a_campos);

        $sql .= " where $this->_primary_key = '" . $this->$nombre_compumal . "'";
        $this->update_log_sql("UPD", $sql);
        //echo $sql."<br>-<br>";
        //exit;
        return $this->_DB->db_query($sql);
    }

    function update_log_sql($tipo, $sql) {
        
    }

    /** Metodo para actualizar un registro
     * @access public
     * */
    public function doUpdateByCols($a_cols, $cache = false) {

        if (is_array($a_cols)) {
            $tem_array = array();
            foreach ($a_cols as $a_ids => $a_values) {
                $tem_array[] = $a_ids . "='" . $a_values . "'";
            }
            $str_where = implode(" and ", $tem_array);
        } else {
            $str_where = $a_cols;
        }

        $sql = "
		update $this->_table set 
		";

        $nombre_compumal = $this->_primary_key;
        $row_last_registro = $this->getRowByCols($a_cols, $cache, true);

        //var_dump($row_last_registro); exit;
        //var_dump($this->_columnas); exit;


        $a_campos = array();
        foreach ($this->_columnas as $nombre_camp_id => $values_camp) {
            //echo $nombre_camp_id."->".$this->$nombre_camp_id."<br>";
            if ($row_last_registro[$nombre_camp_id] != $this->$nombre_camp_id && $nombre_compumal != $nombre_camp_id) {
                if (isset($this->ra_content_lang)) {
                    if ("l_id" != $nombre_camp_id) {
                        $a_campos[] = $nombre_camp_id . "='" . $this->$nombre_camp_id . "'";
                    }
                } else {
                    $a_campos[] = $nombre_camp_id . "='" . $this->$nombre_camp_id . "'";
                }
            }
        }
        //echo $sql; exit;
        //var_dump($a_campos); exit;
        if (count($a_campos) <= 0) {
            return false;
        }

        //var_dump($a_campos);
        $sql .= implode(",", $a_campos);

        $sql .= " where " . $str_where;
        $this->update_log_sql("UPD", $sql);
        //echo $sql."<br>-<br>";
        //exit;
        return $this->_DB->db_query($sql);
    }

    /** Metodo para borrar un registro
     * @access public
     * */
    public function doDelete($val_primarsssi = "") {
        $nombr_primari = $this->_primary_key;

        if (isset($this->ra_content)) {

            $this->ra_content->getRow($val_primarsssi);


            $rs_langs = getLangs();
            while ($row_langs = $this->nextrow($rs_langs)) {
                //$this->getRowByLang($val_primarsssi,$row_langs['l_id']);
                $this->ra_content_lang->getRowByCols(array("cl_c_id" => $val_primarsssi, "l_id" => $row_langs['l_id']));
                $this->ra_content_lang->doDelete();
                //$this->ra_content_lang->doDeleteByCols(array("cl_c_id"=>$val_primarsssi,"l_id"=>$row_langs['l_id']));

                $prumar = $this->ra_content_lang->_primary_key;
                $val_primarsssi2 = $this->ra_content_lang->$prumar;

                /* eliminado este */
                $sql_delete = "
				delete
				from $this->_table
				where $this->_primary_key = '" . $val_primarsssi2 . "'
				";
                //echo $sql_delete."<--<br>";
                $this->_DB->db_query($sql_delete);
            }

            return $this->ra_content->doDelete();
            ;
        } else {

            if ($val_primarsssi == "") {
                $val_primarsssi = $this->$nombr_primari;
            }

            $sql_delete = "
			delete
			from $this->_table
			where $this->_primary_key = '" . $val_primarsssi . "'
			";
            //echo $sql_delete."<>--<br>";
            return $this->_DB->db_query($sql_delete);
        }
    }

    public function doDeleteByCols($a_cols) {
        if (is_array($a_cols)) {
            $tem_array = array();
            foreach ($a_cols as $a_ids => $a_values) {
                $tem_array[] = $a_ids . "='" . $a_values . "'";
            }
            $str_where = implode(" and ", $tem_array);
        } else {
            $str_where = $a_cols;
        }

        $sql = "
		delete 
		from $this->_table
		where  " . $str_where . "
		";
        //echo $sql."<<<<br>";
        return $this->_DB->db_query($sql);
    }

    /* ----------------------Metodos adicionales ------------------------------- */

    /**
     * Retorna el max id.
     * @access public
     * @return int
     */
    public function max($whereadd = "", $nombr_primari = "") {
        /* solo mysql */
        if ($nombr_primari == "") {
            $nombr_primari = $this->_primary_key;
        }


        $sql_max = "
		select max(" . $nombr_primari . ") as col_max
		from $this->_table		
		";
        if ($whereadd != "") {
            $sql_max .= " where " . $whereadd;
        }
        $result = $this->_DB->db_query($sql_max);
        if ($row = $this->_DB->db_fetchrow($result)) {
            return $row["col_max"];
        } else {
            return 0;
        }
    }

    /**
     * Retorna el min id.
     * @access public
     * @return int
     */
    public function min() {
        /* solo mysql */
        $nombr_primari = $this->_primary_key;

        $sql_max = "
		select min(" . $nombr_primari . ") as col_max
		from $this->_table		
		";
        $result = $this->_DB->db_query($sql_max);
        if ($row = $this->_DB->db_fetchrow($result)) {
            return $row["col_max"];
        } else {
            return 0;
        }
    }

    public function newId($prefx, $len) {

        $pref = $prefx; //Prefijo del ID
        $id = null;
        $last_id = $this->max();
        for ($i = 0; $i < strlen($last_id); $i++) {
            $char = substr($last_id, $i, 1);
            settype($char, "int");
            $id .= $char;
        }
        return $pref . str_pad($id + 1, $len, "0", STR_PAD_LEFT);
    }

    public function nextRow(&$rs) {
        return $this->_DB->db_fetchrow($rs);
    }

    public function getAllPag($eWhere = "", $orderby = "", $nr = 10) {
        $where = "";

        if ($eWhere != "") {
            if (is_array($eWhere)) {
                $where = $this->getWhere($eWhere);
            } else if (is_string($eWhere)) {
                $where = $eWhere;
            }
        }

        $add_where = "";

        if ($where != "") {
            $add_where = " where $where ";
        }

        $add_orderby = "";

        if ($orderby != "") {
            $add_orderby = " order by " . $orderby . " ";
        }

        $add_limit = "";

        if ($limit != "") {
            $add_limit = " limit " . $limit . " ";
        }

        $sql = "
		select *
		from $this->_table
		" . $add_where . $add_orderby . $add_limit;

        $pbar = new pagbar($this->_DB);
        $pbar->_tag_ini_li = "<li>";
        $pbar->_tag_end_li = "</li>";
        $pbar->pb_limit($nr);
        $pbar->pb_nlinks(7);
        $pbar->pb_sql($sql);

        return array("RS" => $pbar->sql_result(), "PG" => $pbar->pb_str_show_npages());
    }

    public function getAll($eWhere = "", $orderby = "", $limit = "", $cache = false) {
        $where = "";

        if ($eWhere != "") {
            if (is_array($eWhere)) {
                $where = $this->getWhere($eWhere);
            } else if (is_string($eWhere)) {
                $where = $eWhere;
            }
        }

        $add_where = "";

        if ($where != "") {
            $add_where = " where $where ";
        }

        $add_orderby = "";

        if ($orderby != "") {
            $add_orderby = " order by " . $orderby . " ";
        }

        $add_limit = "";

        if ($limit != "") {
            $add_limit = " limit " . $limit . " ";
        }

        $sql = "
		select *
		from $this->_table
		" . $add_where . $add_orderby . $add_limit;
        //echo "aca kdeo";
        //echo $sql."<br>";
        //var_dump($this->_DB); exit;
        return $this->_DB->db_query($sql, $cache);
    }

    public function getWhere($aWhere) {
        //var_dump($aWhere); exit;
        return implode(" and ", $aWhere);
    }

    public function parceRsToArray($rs) {

        $a_return = array();
        while ($row = $this->_DB->db_fetchrow($rs)) {
            $now_this = "";
            foreach ($row as $row_id => $row_value) {
                if (is_string($row_id)) {
                    //echo $row_id."<br>";
                    $now_this->$row_id = $row_value;
                }
            }
            $a_return[] = $now_this;
            //exit;
        }

        return $a_return;
    }

}

?>